2006-09-11  Roger Leigh  <rleigh@debian.org>

	* Version 1.0.2.

	* debian/changelog: Finalise for 1.0.2.

2006-08-25  Roger Leigh  <rleigh@debian.org>

	* po/schroot.pot: Add.

2006-08-19  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document --directory.

2006-08-19  Roger Leigh  <rleigh@debian.org>

	* Merge from mainline.

	* HACKING: Document additional directory fallback checks.

	* schroot/schroot.1.in, dchroot/dchroot.1.in,
	dchroot-dsa/dchroot-dsa.1.in: Document directory option.

	* schroot/schroot-main-base.cc
	(run_impl): If a directory option was specified, set the auth wd
	member.

	* schroot/schroot-options.cc, dchroot/dchroot-options.cc,
	dchroot-dsa/dchroot-dsa-options.cc:
	(add_options): Add directory option.

	* schroot/schroot-options-base.h: Add directory member, used to
	specify the directory inside the chroot.

	* dchroot/dchroot-session.cc, dchroot-dsa/dchroot-dsa-session.cc
	(get_login_directories): Use working directory in place of the
	normal directory fallback list if set.

	* sbuild/sbuild-session.cc
	(get_login_directories, get_command_directories): Use working
	directory in place of the normal directory fallback list if set.

	* sbuild/sbuild-auth.cc (get_wd, set_wd): New methods.  Get and
	set the working directory.

	* sbuild/sbuild-auth.h: Add wd member variable to store the
	working directory to use.

2006-08-18  Roger Leigh  <rleigh@debian.org>

	* Merge from mainline.

	* schroot/schroot-base-options.cc,
	schroot/schroot-options-base.cc,
	schroot/schroot-listmounts-options.cc,
	schroot/schroot-releaselock-options.cc
	(add_option_groups): Add workaround for boost if
	BOOST_PROGRAM_OPTIONS_DESCRIPTION_OLD is defined.

	* configure.ac: Add check for
	boost::program_options::options_description::options(), which does
	not exist in older versions of boost.

2006-08-07  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #381695.

	* NEWS: Document changed syslog behaviour.

	* sbuild/sbuild-session.cc
	(get_login_command, get_user_command): syslog logging of the
	command or shell being run in the chroot now only occurs when
	running as root or switching to another user.

2006-08-06  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 1.0.2.

	* NEWS: Bump version to 1.0.2.

	* configure.ac: Bump version to 1.0.2.

2006-08-03  Roger Leigh  <rleigh@debian.org>

	* Version 1.0.1.

2006-08-03  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #381271.

2006-08-03  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot.cc
	(set_location): Be less strict when validating the location;
	strict validation is already performed in derived chroot types.
	This prevents errors when reading the session configuration.

2006-08-02  Luk Claes  <luk@debian.org>

	* po/sv.po: Update Swedish translation.

2006-08-01  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 1.0.1.

	* NEWS: Bump version to 1.0.1.

	* configure.ac: Bump version to 1.0.1.

2006-08-01  Luk Claes  <luk@debian.org>

	* po/cs.po: Update Czech translation.

2006-07-31  Roger Leigh  <rleigh@debian.org>

	* Version 1.0.0.

	* debian/changelog: Update for 1.0.0.

2006-07-31  Roger Leigh  <rleigh@debian.org>

	* Merge from trunk.

	* schroot/schroot.1.in, dchroot/dchroot.1.in: Document mips and
	mipsel personality bug.

2006-07-31  Roger Leigh  <rleigh@debian.org>

	* Merge from trunk.

	* schroot/setup/50chrootname: Name in log message always matches
	debian_chroot chrootname.

2006-07-30  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-types.cc: Include sbuild-i18n.h here, rather than
	the header.

	* Update translator comments.

2006-07-30  Roger Leigh  <rleigh@debian.org>

	* po/LINGUAS: Add cs.

2006-07-30  Luk Claes  <luk@debian.org>

	* po/cs.po: Add Czech translation.

2006-07-30  Roger Leigh  <rleigh@debian.org>

	* Update translations.

2006-07-30  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Fix --enable-dchroot-dsa help string.  Thanks to
	Jens Seidel <jensseidel@users.sf.net> for reporting this.

	* schroot/schroot-options-base.cc
	(check_actions): Clarify error message when starting a session,
	and the number of chroots specified is not 1.  Thanks to Jens
	Seidel <jensseidel@users.sf.net> for reporting this.

	* schroot/schroot-base-main.cc
	(action_version): Fix translator comment.  Thanks to Jens Seidel
	<jensseidel@users.sf.net> for reporting this.

	* sbuild/Makefile.am
	(sbuild_public_cc_sources): Add sbuild-types.cc.

	* sbuild/sbuild-types.cc: New file.
	(get_date_format): Get a localised strftime format string.

	* sbuild/sbuild-types.h (operator <<): Allow localisation of the
	std::time_put format string.

2006-07-29  Roger Leigh  <rleigh@debian.org>

	* debian/copyright: Add location of SVN schroot-1.0 branch.

2006-07-29  Roger Leigh  <rleigh@debian.org>

	* Update translations.

2006-07-29  Roger Leigh  <rleigh@debian.org>

	* TODO: Add future items.

	* All catch blocks catch const references.

	* sbuild/sbuild-run-parts.cc
	(run_child): Handle exceptions thrown in child.

	* sbuild/sbuild-session.cc
	(setup_chroot): Handle exceptions thrown in child.

	* Replace all uses std::locale("C") with std::locale::classic().

	* Replace all uses of NULL with 0.

	* sbuild/sbuild-auth.cc
	(auth): Remove redundant auth_conv_tty dynamic_cast.
	(~auth): Log an error if an exception is caught.
	(set_user): Default uid and gid to current uid and gid, rather
	than 0, for extra safety when an error occurs.
	(run, start): Use reinterpret_cast instead of static_cast when
	casting void *.
	(authenticate): Don't leak hostname array if an exception is
	thrown.

2006-07-29  Roger Leigh  <rleigh@debian.org>

	* Update manual pages.

	* sbuild/sbuild-lock.h: Add missing virtual specifier from virtual
	methods in derived lock classes.

	* sbuild/sbuild-session.cc: Remove use of excess braces when
	throwing exceptions.
	(get_shell): Use log_exception_warning.

	* Remove incorrect and misplaced comments.

	* Update translator comments.

	* Update API reference to document all missing and incomplete
	documentation.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* NEWS: Update for 1.0.0.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am
	(libschroot_base_la_SOURCES): Distribute schroot-base-run.h.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* po/LINGUAS: Rename en_GB to en.

	* po/en.po: Rename from en_GB.po.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Add en- and em-dashes.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-listmounts-main.(cc|h),
	schroot/schroot-releaselock-main.(cc|h): Use opts rather than
	options as the member name for the options smartpointer; this
	doesn't conflict with the options class in the same namespace, and
	fixes a compile error with GCC 3.3.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-config.cc (load_data): Fix comment.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.cc
	(save_termios, restore_termios): Close CTTY fd to prevent fd leak.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc, schroot/schroot-listmounts.cc,
	schroot/schroot-releaselock.cc, dchroot/dchroot.cc,
	dchroot-dsa/dchroot-dsa.cc: Use schroot_base::run<>.

	* schroot/schroot-base-run.h: New file.  Implement a generic
	templated main routine.

2006-07-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-base-main.cc
	(run): Remove locale and gettext setup.

	* schroot/schroot.cc, schroot/schroot-listmounts.cc,
	schroot/schroot-releaselock.cc, dchroot/dchroot.cc,
	dchroot-dsa/dchroot-dsa.cc: Set up locale and gettext message
	catalogue.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth-conv.h: Update API documentation.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth.cc
	(authenticate): Split string definition and appending of
	additional parts into multiple statements, for GCC 3.3
	compatibility.

	* sbuild/sbuild-tr1types.h: If using boost::shared_ptr, import
	static_pointer_cast, const_pointer_cast and dynamic_pointer_cast
	into the std::tr1 namespace for GCC 3.3 and 3.4 compatibility.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* po/de.po: Update German translation.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-releaselock.cc, schroot/schroot.cc,
	schroot/schroot-listmounts.cc, sbuild/sbuild-parse-error.h,
	sbuild/sbuild-auth.cc, sbuild/sbuild-auth.h, dchroot/dchroot.cc,
	dchroot-dsa/dchroot-dsa.cc: Fix typo (occured).  Thanks to Jens
	Seidel <jensseidel@users.sf.net> for reporting this.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* po/LINGUAS: Add de.

	* po/de.po: New file.  German translation from Jens Seidel.

2006-07-27  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-listmounts-main.cc
	(action_listmounts): mounts is const, to fix a GCC 4.0 compiler
	bug.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Add missing Debian-specific revisions.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: debian/copyright updates.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* po/LINGUAS: Add vi.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 1.0.0.

	* NEWS: Bump version to 1.0.0.

	* configure.ac: Bump version to 1.0.0.

2006-07-20  Luk Claes  <luk@debian.org>

	* po/vi.po: Update Vietnamese translation.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* Version 0.99.4

	* debian/changelog: Update for 0.99.4

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update translation.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item (duplictes in conffiles should be an
	error).

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth.h: Remove incorrect comment.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.cc
	(run_impl): Make sure setup_chroot (for EXEC_STOP and SETUP_STOP),
	clear_sigterm_handler, and clear sighup_handler are always called,
	and always called once only.

	* sbuild/sbuild-auth.cc
	(run): Make sure cred_delete and stop are always called, and
	always called once only.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-run-parts.cc (run_child): Add child exit status
	debugging output.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* Don't translate program usage messages before the locale and
	gettext have been initialised.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document SIGTERM behaviour.

	* sbuild/sbuild-session.cc
	(set_signal_handler): New method for use by set_sighup_handler and
	set_sigterm_handler.
	(clear_signal_handler): New method for use by clear_sighup_handler
	and clear_sigterm_handler.
	(set_sighup_handler): Use set_signal_handler.
	(clear_sighup_handler): Use clear_signal_handler.
	(set_sigterm_handler): New method.
	(clear_sigterm_handler): New method.

	* sbuild/sbuild-session.h: Rename saved_signals member to
	saved_sighup_signal, and add a saved_sigterm_signal member.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth-conv-tty.cc (conversation): Log using
	standard log functions rather than using std::cerr.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-log.cc: Add translator comments, and mark up log
	abbreviations for translation.

2006-07-20  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* Added a number of debugging messages to important codepaths.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* po/vi.po: Restore unmaintained translation, but leave out of
	LINGUAS.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* po/sv.po: Update Swedish translation.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update.

	* Add translator comments for ellipsis (...) in translatable
	strings.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #378469.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document terminal state save and restore behaviour.

	* sbuild/sbuild-session.cc
	(save_termios): New method.  Save terminal state.
	(restore_termios): New method.  Restore terminal state.
	(run_impl): Save and restore terminal state between opening and
	closing the session.

	* sbuild/sbuild-session.h: Add saved_termios and termios_ok
	members.

	* schroot/schroot-base-main.cc (run): Remove termios save and
	restore.

2006-07-19  Roger Leigh  <rleigh@debian.org>

	* po/LINGUAS: Remove vi.

	* po/vi.po: Remove currently unmaintained translation.

	* po/en_GB.po: Update

	* Add translation comments documenting all format string arguments
	before all translatable strings with %n% format modifers.

2006-07-18  Luk Claes  <luk@debian.org>

	* po/sv.po: Update Swedish translation.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* dchroot/dchroot.1.in, dchroot-dsa/dchroot-dsa.1.in: Remove
	accidentally committed SVN conflict markers.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth-conv-tty.cc
	(get_delay): Fix incorrectly named function call.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* po/en_GB.po: Update translation.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* Use log_exception_error and log_exception_error in place of
	log_error and log_warning.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document stricter duplicate checking, and improved error
	reporting.

	* dchroot/dchroot-chroot-config.cc,
	dchroot-dsa/dchroot-dsa-chroot-config.cc: Duplicate chroot names
	are treated as an error.

	* sbuild/sbuild-keyfile.h: Use log_exception_warning in place of
	log_warning.
	(operator >>): Duplicate groups and keys within groups are an
	error.

	* dchroot/dchroot-session-base.cc
	(run_impl): Use arguments with USER_SWITCH.

	* sbuild/sbuild-session.cc: Add format arguments to USER_SWITCH
	error code.

	* sbuild/sbuild-custom-error.h: Add two additional constructors
	with two context arguments.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-main-base.cc: Add error code enum and string
	map.
	(run_impl): Throw custom exception using new error codes.

	* configure.ac (PACKAGE_LOCALSTATE_DIR): Remove trailing /.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-listmounts-main.cc: Add error code enum and
	string map.
	(list_mounts) Throw custom exception using new error codes.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-personality.cc: Add tests for stream operators.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-lock.cc: Rename _RELEASE error codes to _UNLOCK
	and reword error messages to be uniform with chroot error
	messages.

	* sbuild/sbuild-chroot-config.cc: Rename CHROOT error to
	CHROOT_NOTFOUND, to reduce ambiguity.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-log.cc
	(log_exception_error): Rename from log_exception.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* Remove redundant emacs local variables use in C++ sources.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* sbuild/sbuild-chroot.cc
	(set_persona): Remove method overloaded for a string.
	(get_keyfile): Use keyfile::set_object_value for the personality.
	(set_keyfile): Use keyfile::get_object_value for the personality.

	* sbuild/sbuild-personality.cc: Add a BAD error code for when the
	personality name is invalid.
	(get_personalities): Renamed from print_personalities.  Create a
	string, rather than printing to an ostream.

	* sbuild/sbuild-personality.h: Add stream input operator, to set
	the personality from a stream.

	* sbuild/sbuild-keyfile.h: Move all logic in get_object_value into
	the try block, to catch and report parse errors in T parsing.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* dchroot/dchroot.1.in, dchroot-dsa/dchroot-dsa.1.in: Use "users"
	instead of "user list", so that the user list name matches the
	keyfile key name used in error messages.

	* dchroot/dchroot-chroot-config.cc,
	dchroot-dsa/dchroot-dsa-chroot-config.cc (parse_data): A missing
	location is no longer an error (it gets reported with greater
	detail when adding the keyfile).

	* sbuild/sbuild-keyfile.cc: Add additional error code for missing
	required key with no line information.
	(check_priority): Report line information for missing required key
	(when available).

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-config.cc
	(add): Clean up error handling, and report config file line
	number, group and key details.  A keyfile is passed as an
	argument, to provide context for error details.
	(load_keyfile): Pass keyfile as context when calling add.

	* sbuild/sbuild-auth.cc
	(authenticate): Authorisation failure information is set as an
	exception reason.

	* sbuild/sbuild-keyfile.cc: Add additional error codes for
	passthrough, and deprecated and obsolete key warnings.
	(check_priority): Use error codes and exception reasons rather
	than hand-formatted error messages.

	* sbuild/sbuild-session.cc
	(wait_for_child): Tidy termination message.

	* sbuild/sbuild-log.cc
	(log_exception_warning): New method.  This behaves exactly the
	same as log_exception, but uses log_warning rather than log_error.

2006-07-17  Roger Leigh  <rleigh@debian.org>

	* dchroot/dchroot-chroot-config.cc,
	dchroot-dsa/dchroot-dsa-chroot-config.cc
	(parse_data): Instead of creating a chroot and adding it, create a
	keyfile and load it.  This will allow accurate parse errors,
	including line numbers.

	* sbuild/sbuild-chroot-config.cc
	(load_keyfile): New method, split from parse_data.  This allows
	keyfile loaded in derived classes.

	* sbuild/sbuild-keyfile.h: Methods to set values with line numbers
	are now public, for use in dchroot.  Added method to set a list
	value with a line number.

2006-07-16  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Use -p rather than -d in the description,
	and remove incorrect directory fallback description.  Thanks to
	Matthew Foulkes for reporting this.

2006-07-16  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed items.

	* All code logging exceptions with log_error() and e.what() use
	log_exception.

	* sbuild/sbuild-auth.cc (auth_conv_hook): In the PAM conversation
	hook, catch and handle any exception thrown by a conversation
	handler.

	* sbuild/sbuild-auth-conv-tty.cc (conversation): Rather than
	returning false on error, throw an exception.  Remove exception
	catching logic; it's now handled in sbuild::auth.

	* sbuild/sbuild-auth-conv.h (conversation): Rather than returning
	false on error, throw an exception.

	* sbuild/sbuild-log.(cc|h) (log_exception): New function.  This
	helper function outputs an exception using log_error(), and
	exception reasons using log_info().

	* sbuild/sbuild-parse-error.h: All constructors add a call for
	format_reason in addition to format_detail.  All detail arguments
	are templated rather than strings (to allow use of exceptions as
	detail).

	* sbuild/sbuild-custom-error.h: All constructors add a call for
	format_reason in addition to format_detail.

	* sbuild/sbuild-error.h, sbuild/sbuild-error.tcc: Add error_base
	class.  This contains a reason string with a why() method in
	addition to the what() method provided by std::exception.  error<>
	derives from error_base, and provides a format_reason helper with
	similar behaviour to format_detail.  Both format_detail and
	format_reason contain templated helper classes to allow conversion
	of exceptions of any type, and the transfer of their reason (if
	any).

	* configure.ac: Add check for boost/type_traits.hpp.

2006-07-16  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in, dchroot/dchroot.1.in,
	dchroot-dsa/dchroot-dsa.1.in: Add all options to the synopsis
	section.

2006-07-15  Roger Leigh  <rleigh@debian.org>

	* debian/changelog, debian/rules: Fix problem in config.status
	rule.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.99.4.

	* NEWS: Bump version to 0.99.4.

	* configure.ac: Bump version to 0.99.4.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* Version 0.99.3

	* debian/changelog: Finalise for 0.99.3.

	* schroot/schroot-releaselock-main.cc: Fix typo.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* HACKING: Document manual chroot fallback testing.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* TODO: Add remaining items for 1.0.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-null.h: Remove completed TODO item.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* schroot/schroot.conf.5.in: Add undocumented features.

	* schroot/schroot.conf: Add undocumented features.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* THANKS: Add Simon Richter.

	* sbuild/sbuild-session.cc
	(run_impl): Move session opening and closing here.  The session is
	opened and closed outside the chroot as root.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* Update doxygen API reference.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-base-main.cc
	(run): Return rather than calling exit.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #378152.

	* Having a single exit point now means terminal settings are
	always restored correctly.

	* sbuild/sbuild-run-parts.cc: Use _exit rather than exit when
	terminating a child process when execve has failed.

	* sbuild/sbuild-session.cc: Use _exit rather than exit when
	terminating a child process when execve has failed.

	* schroot/schroot-releaselock-main.(cc|h): Add error_code enum and
	error typedef for sbuild::custom_error.  Throw error in place of
	exiting with EXIT_FAILURE.

	* schroot/schroot-main-base.(cc|h): Add error_code enum and error
	typedef for sbuild::custom_error.  Throw error in place of exiting
	with EXIT_FAILURE.  Don't ever exit successfully; return a success
	status.

	* schroot/schroot-base-main.cc (run): Don't catch "..."; it's
	handled by the main() stubs.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-directory.cc (setup_env): Remove.
	CHROOT_LOCATION is already set in the parent class.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Minor whitespace cleanup.

	* TODO: Remove completed item.

	* Updated British English translation.

	* Apply quoting style to all sources.

	* HACKING: Document quoting style for format strings.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* HACKING: Document how to build the printed documentation.

	* Makefile.am: Add ps and pdf phony targets.

	* doc/Makefile.am: Add rules to make PS and PDF manuals.

2006-07-14  Roger Leigh  <rleigh@debian.org>

	* Update all documentation to use the style guidelines.

	* Makefile.am: Distribute HACKING.

	* HACKING: New file.  Document manual page style guidelines.

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* Update sources to use new header.

	* sbuild/Makefile.am: Add sbuild-null.(cc|h).

	* sbuild/sbuild-null.(cc|h): New file.  Split out null class from
	sbuild/sbuild-error.h

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed error string markup item.

	* Add boost::format markup to error strings.

	* sbuild/sbuild-custom-error.h: All constructor detail arguments
	are now templated.  Add additional constructors for multiple detail
	arguments.

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot.h: API documentation corrections.

	* sbuild/sbuild-chroot.cc
	(set_persona): New overloaded function to set the personality by
	name.
	(set_keyfile): Set the personality using
	keyfile::get_object_value.

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* All sources use error<> in place of custom_error_base<>, and
	std::runtime_error in place of runtime_error.

	* sbuild/sbuild-error.tcc: Renamed from sbuild-custom-error.tcc.

	* sbuild/sbuild-error.h: Remove runtime_error.  Move
	custom_error_base from sbuild/custom-error.h and rename to error.

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-parse-value.cc: Use sbuild::parse_value_error in
	place of sbuild::parse_error.

	* dchroot/dchroot-chroot-config.cc,
	dchroot-dsa/dchroot-dsa-chroot-config.cc: Use
	sbuild::keyfile::error in place of sbuild::parse_error.

	* sbuild/sbuild-environment.cc: Use parse_value_error in place of
	parse_error.

	* sbuild/sbuild-keyfile.cc: Add error strings.  Use error in place
	of parse_error.

	* sbuild/sbuild-keyfile.h: Add error_code enum and error typedef
	specialisation of parse_error<>.  Use error and parse_value_error
	in place of parse_error.  Include line numbers in all exceptions
	where a line number is available.

	* sbuild/sbuild-parse-value.cc: Add parse_value_error error
	strings.  Use parse_value_error in place of parse_error.

	* sbuild/sbuild-parse-value.h: Add parse_value_error_code enum and
	parse_value_error typedef specialisation of parse_error<>.  Use
	parse_value_error in place of parse_error.

	* sbuild/sbuild-custom-error.tcc: format_error methods are inline.

	* sbuild/sbuild-custom-error.h: format_error methods are static.
	Remove commented-out typedef.

	* sbuild/sbuild-parse-error.cc: Remove.

	* sbuild/sbuild-parse-error.h: parse_error is now a templated
	class, derived from custom_error_base<>.
	custom_error_base<>::format_error is used for all formatting.
	Methods for passing through exceptions of different types have
	been added.

2006-07-13  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #378028.

	* dchroot/dchroot.1.in: Document command option syntax.

	* NEWS: Document dchroot command option syntax.

	* dchroot/dchroot-session.cc
	(get_user_command): Concatenate all command options into a single
	command, separated by spaces.

	* dchroot/dchroot-options.cc
	(check_options): Allow any number of command options.

2006-07-12  Roger Leigh  <rleigh@debian.org>

	* All sources defining a custom_error<>::error_strings map define
	a custom_error_base<>::error_strings map instead.

	* sbuild/sbuild-custom-error.h: Split custom_error formatting
	functions, typedefs and static members into a custom_error_base
	class.

2006-07-12  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-custom-error.tcc
	(format_error): Add a third context argument, for use with keyfile
	errors.

2006-07-12  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-custom-error.tcc
	(format_error): Never pass more arguments than the format string
	specifies.

2006-07-12  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-config.cc
	(load_data): Use new error contructor.

	* sbuild/sbuild-session.cc
	(wait_for_child): Use new error contructor.

	* sbuild/sbuild-custom-error.tcc
	(format_error): Replace all overloaded functions with two
	variants, one for an error_type enum, one for an exception (for
	rethrowing an exception of a different type).

	* sbuild/sbuild-custom-error.h: Add new custom_error<>::null
	class, used to represent an absent context or detail item in an
	error.  Add two new constructors for rethrowing exceptions.

2006-07-12  Roger Leigh  <rleigh@debian.org>

	* All sources use strerror(errno) in place of errno when creating
	a custom_error<>.

	* sbuild/sbuild-custom-error.h: Remove all constructors with
	integer errno arguments.

2006-07-10  Roger Leigh  <rleigh@debian.org>

	* debian/rules: Build in debian/build using VPATH.

	* debian/changelog: Add VPATH build.

2006-07-10  Roger Leigh  <rleigh@debian.org>

	* All Makefile.ams: include global.mk.

	* scripts/global.mk: New file.  Global Makefile options.

2006-07-10  Roger Leigh  <rleigh@debian.org>

	* Don't include <syslog.h> in sources not using syslog.

2006-07-10  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-main-base.cc (run_impl): Remove code duplicated
	in schroot_base::main::run (termios saving and restoring, and
	exception handling).

2006-07-10  Roger Leigh  <rleigh@debian.org>

	* debian/schroot.docs: Add the contents of debian/docs.

	* debian/docs: Remove.

	* debian/rules: The /usr/share/doc directories for dchroot and
	dchroot-dsa are symlinks to schroot.

	* debian/dchroot.preinst: New file.  Remove
	/usr/share/doc/dchroot.

	* debian/dchroot-dsa.preinst: New file.  Remove
	 /usr/share/doc/dchroot-dsa.

	* debian/changelog: Update.

2006-07-09  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document the new "directory" chroot type.

	* schroot/schroot.conf.5.in, schroot/schroot-setup.5.in: Document
	new "directory" chroot type.

	* schroot/setup/00check, schroot/setup/10mount,
	schroot/setup/00check: Add logic for "directory" CHROOT_TYPE.  The
	"directory" type will mount the chroot location with --rbind, like
	"plain", but will additionally mount filesystems like all other
	chroot types.

	* sbuild/Makefile.am: Add sbuild-chroot-directory.(cc|h).

	* sbuild/sbuild-chroot.cc (create): Add support for the
	"directory" chroot type.

	* sbuild/sbuild-chroot-plain.(cc|h): chroot_plain derives from
	chroot_directory.  It is exactly the same as directory except for
	the chroot name.

	* sbuild/sbuild-chroot-directory.(cc|h): New files.  The directory
	class is based upon the "plain" chroot type.

2006-07-09  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-dirstream.h: The dirstream extraction operator is
	declared outside the class, in addition to the friend declaration.
	This fixes a compilation error with GCC 4.2.  Thanks to Martin
	Michlmayr for reporting this.

	* debian/changelog: Close #377433.

2006-07-07  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-personality.cc: Update test to cope with Linux
	systems building with a personality other than PER_LINUX.

2006-07-06  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.99.3.

	* NEWS: Bump version to 0.99.3.

	* configure.ac: Bump version to 0.99.3.

2006-07-06  Roger Leigh  <rleigh@debian.org>

	* Version 0.99.2

	* debian/changelog: Finalise for 0.99.2.

2006-07-06  Roger Leigh  <rleigh@debian.org>

	* README: Update build dependencies.

2006-07-06  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document new features.

2006-07-06  Roger Leigh  <rleigh@debian.org>

	* test/*.cc: Replace SRCDIR with TESTDATADIR.

	* test/Makefile.am
	(AM_CXXFLAGS): Replace SRCDIR with TESTDATADIR.
	(TESTS): Run setup-test-data and cleanup-test-data at the start
	and end of testing, respectively.
	(EXTRA_DIST): Distribute setup-test-data and cleanup-test-data.
	(clean-local): Run cleanup-test-data.

	* test/cleanup-test-data: New file.  Remove testdata directory.

	* test/setup-test-data: New file.  Copy test data to testdata
	directory and change the ownership to root.

2006-07-03  Roger Leigh  <rleigh@debian.org>

	* README: Document new Boost build dependency.

	* TODO: Remove completed item.

	* sbuild/sbuild-session.cc
	(setup_chroot): Use sbuild::run_parts in place of run-parts(8).

	* configure.ac: Remove run-parts(8) checks.

2006-07-03  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-run-parts.cc: Add run-parts tests.

	* test/run-parts.ex?: Add run-parts test scripts.

	* configure.ac: Add check for libboost_regex.

	* sbuild/Makefile.am: Add sbuild-run-parts sources.

	* sbuild/sbuild-run-parts.(cc|h): New files.  This class
	reproduces the functionality of run-parts(8).

	* sbuild/sbuild-util.cc (exec): Add (moved from sbuild-session).

	* sbuild/sbuild-session.cc (exec): Remove.

2006-07-03  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-personality.cc: Sync tests with current personality
	behaviour.

	* test/sbuild-dirstream.cc: Remove unused environment members, and
	an unused header.

	* test/Makefile.am (sbuild_personality_SOURCES): Correct sources.

2006-07-01  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-dirstream.cc: New file.  Tests for
	sbuild::dirstream.

	* sbuild/sbuild-dirstream.(cc.h): New files.  This class provides
	a "directory stream" interface to the SUS directory functions.

2006-06-29  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* sbuild/sbuild-chroot-config.cc
	(parse_data): Remove exception wrapper, now that sbuild::keyfile
	throws exceptions containing more detailed information.

	* sbuild/sbuild-chroot-file.cc
	(get_file_repack, set_file_repack): New methods to get and set
	file repack status.

	* All chroot get_keyfile and set_keyfile methods are implemented
	in terms of the new keyfile::[gs]et_object_(list_)value methods.

	* sbuild/sbuild-keyfile.h: Add templated static methods for
	getting and setting key values and list values using pointers to
	methods of other objects.

2006-06-29  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-keyfile.cc: Add test for getting line numbers.

	* sbuild/sbuild-keyfile.h:
	(item_type, group_type): Add line number to both tuples.
	(set_value): Add overloaded private method which adds a line
	number to its arguments.
	(operator >>): Set line numbers when deserialising.

	* sbuild/sbuild-keyfile.cc
	(get_line): New methods for getting the line numbers of groups and
	keys.
	(set_group): Add overloaded private method which adds a line
	number to its arguments.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed item.

	* sbuild/sbuild-util.cc (narrow_string, widen_string): Throw a
	runtime_error on conversion failure.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-auth.cc: Fix switched authentication and
	authorisation messages.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in, dchroot/dchroot.1.in,
	dchroot-dsa/dchroot-dsa.1.in: Document debug levels.

	* schroot/schroot-base-options.(cc|h)
	(check_options): Check the debug level given with --debug.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* Clean up locale and exception handling in all main stub
	routines.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed items.

	* schroot/schroot-base-main.cc
	(run): This method takes argc and argv arguments, and calls the
	option class parse method.  It also catches and handles parse
	exceptions.

	* schroot/schroot-base-option.cc
	(parse): Renamed from parse_options, this method now takes argc
	and argv as arguments and calls all the other class virtual
	methods to set up and process the options.
	(add_option_group): New virtual method.  The addition of option
	groups is split out from the parse method.

	* All option parsing classes have removed the argc and argv
	arguments from their constructors.  The constructors now no longer
	call any of the virtual methods.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-listmounts-options.cc: Add set_action method to
	ensure only one action is specified.

	* schroot/schroot-releaselock-options.cc: Add set_action method to
	ensure only one action is specified.

2006-06-28  Roger Leigh  <rleigh@debian.org>

	* dchroot-dsa/dchroot-dsa-main.cc: Use new constructor argmuments,
	and chain up to the new parent class.

	* dchroot-dsa/dchroot-dsa-options.cc: Remove help check, which is
	handled in the base class.  Handle help action in sanity checks.

	* dchroot/dchroot-main.cc: Use new constructor argmuments, and
	chain up to the new parent class.

	* dchroot/dchroot-main-base.(cc|h): Derive from
	schroot::main_base.

	* dchroot/dchroot-options.cc: Remove help check, which is handled
	in the base class.

	* schroot/schroot-main.(cc|h): Derive from main_base.  Remove
	functionality moved to the base class.

	* schroot/schroot-options-base.(cc|h): Derive from
	schroot_base::options.  Remove functionality moved to the base
	class.  Add help action.

	* schroot/schroot-options.cc: Remove help check, which is handled
	in the base class.

	* schroot/schroot-listmounts.cc: Move functionality into
	schroot_listmounts::main.

	* schroot/schroot-listmounts-options.(cc|h): Derive from
	schroot_base::options and implement actions.

	* schroot/schroot-releaselock.cc: Move functionality into
	schroot_releaselock::main.

	* schroot/schroot-releaselock-options.(cc.h): Derive from
	schroot_base::options and implement actions.

	* schroot/Makefile.am: Add schroot_base::main and
	schroot_base::options to a new libschroot-base.la library.
	libschroot and the helper binaries use this base library.

	* schroot/schroot-main-base.(cc|h): New files.  This class
	contains functionality common to all schroot programs (schroot,
	dchroot, dchroot-dsa), split out from schroot/schroot-main.cc.  It
	is derived from schroot_base::main.

	* schroot/schroot-listmounts-main.(cc|h): New files.  This class
	implements the frontend for schroot-listmounts.  It contains logic
	moved from schroot/schroot-listmounts.cc.  It is derived from
	schroot_base::main.

	* schroot/schroot-releaselock-main.(cc|h): New files.  This class
	implements the frontend for schroot-releaselock.  It contains
	logic moved from schroot/schroot-releaselock.cc.  It is derived
	from schroot_base::main.

	* schroot/schroot-base-options.(cc|h): New files.  This class
	implements the functionality common to all options parsing
	classes.

	* schroot/schroot-base-main.(cc|h): New files.  Frontend base for
	schroot programs.  This class is used to "run" schroot programs.
	It contains functionality common to all * programs, such as help
	and version output.


2006-06-26  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.cc (is_group_member): Rather than exiting
	with failure status, warn and return false, or throw an exception.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* debian/schroot.docs: Add.  Include THANKS.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* scripts/setperms: New file.  Helper to set binaries setuid root
	for testing.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.99.2.

	* NEWS: Bump version to 0.99.2.

	* configure.ac: Bump version to 0.99.2.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* TODO: Add TODO items for 1.0.

	* test/sbuild-keyfile.cc: Update testcases.

	* test/sbuild-parse-value.cc: Update testcases.

	* sbuild/sbuild-environment.h: Use new parse_value syntax.

	* sbuild/sbuild-keyfile.h: Use new parse_value syntax.
	get_list_value now correctly reports parse errors in list values.

	* sbuild/sbuild-parse-value.(cc|h): Convert from a class back into
	separate functions.  This gets rid of annoying uninitialised value
	errors.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* Version 0.99.1

	* debian/changelog: Finalise for 0.99.1.

	* sbuild/sbuild-session.cc: Document CHDIR_FB.

	* dchroot-dsa/dchroot-dsa.1.in: Document original dchroot-dsa
	authors.

2006-06-26  Roger Leigh  <rleigh@debian.org>

	* dchroot-dsa/dchroot-dsa-options.cc
	(check_options): Add check to ensure a chroot must be specified,
	to prevent use of the "default" fallback.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* Update API reference, fixing a few undocumented members and
	updating the doxygen config file.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #373943.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc, dchroot/dchroot.cc,
	dchroot-dsa/dchroot-dsa.cc: On an options parsing error, recommend
	the user use --help.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* All headers using tr1::shared_ptr or tr1::tuple include
	sbuild-tr1types.h.

	* sbuild/sbuild-tr1types.h: New header.  Include tr1 or boost
	shared_ptr and tuple headers into the tr1 namespace.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.cc
	(wait_for_child): pid is a pid_t, not int.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-releaselock.cc (print_version): Use gmdate.

	* schroot/schroot-listmounts.cc (print_version): Use gmdate.

	* dchroot/dchroot-main-base.cc
	(action_config): Add current date to header comment.  Print help
	comments only if using dchroot.conf.

	* schroot/schroot-main.cc
	(action_version): Use gmdate.
	(action_config): Add current date to header comment.

	* sbuild/sbuild-types.h (sbuild): Split date into gmdate and date
	clases for UTC and local dates respectively, with a date_base
	class to handle common formatting.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* Remove redundant includes from all headers.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* THANKS: Add adeodato, aeb, tbm and vorlon.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* README: Document non-standard configure options.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-lvm-snapshot.cc
	(get_keyfile): Don't save the "lvm-snapshot-device" attribute
	unless the chroot is active.

	* sbuild/sbuild-chroot-file.cc
	(get_keyfile): Don't save the "file-repack" attribute unless the
	chroot is active.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-block-device.cc
	(get_location): Restore
	(set_location): Restore
	(get_keyfile): Restore "location".
	(set_keyfile): Restore "location".  "location" (if specified) must
	be absolute.

	* sbuild/sbuild-chroot-config.cc (print_chroot_config): Don't
	output generated chroots.

	* sbuild/sbuild-chroot-source.cc (clone_source_setup): Set the
	chroot originality to false when cloning.

	* sbuild/sbuild-chroot.(cc|h): Add "original" member, plus getter
	and setter.  This records if the chroot was automatically
	generated or not.  Don't check of "mount-device" is absolute if
	it's empty, since this is optional.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document strict absolute path checks.

	* sbuild/sbuild-chroot-config.cc
	(parse_data): Catch and report chroot deserialisation errors.

	* sbuild/sbuild-chroot-plain.cc
	(set_keyfile): "location" must be absolute.

	* sbuild/sbuild-chroot-file.cc
	(set_keyfile): "file" must be absolute.

	* sbuild/sbuild-chroot.cc
	(set_keyfile): "mount-device" and "mount-location" must be
	absolute.

	* sbuild/sbuild-chroot-lvm-snapshot.cc
	(set_keyfile): "lvm-snapshot-device" must be absolute.

	* sbuild/sbuild-chroot-block-device.cc
	(get_location): Remove unused function
	(set_location): Remove unused function
	(get_keyfile): Remove "location".
	(set_keyfile): Obsolete "location".  "device" must be absolute.

	* sbuild/sbuild-chroot.h (sbuild): Add DEVICE_ABS, FILE_ABS and
	LOCATION_ABS error codes.

	* sbuild/sbuild-keyfile.cc (check_priority): Add missing break in
	switch.

	* dchroot-dsa/dchroot-dsa-session.cc (get_user_command): Throw a
	COMMAND_ABS error if the command is not absolute.

	* sbuild/sbuild-session.(cc|h): Add a COMMAND_ABS error code.

	* dchroot-dsa/dchroot-dsa-options.cc (check_options): Throw an
	error if the command is not an absolute path.  This optimisation
	means a session is not set up if it is already known it will fail.

	* sbuild/sbuild-util.cc (is_absname): New function.  This checks
	if a path is absolute.

2006-06-25  Roger Leigh  <rleigh@debian.org>

	* All derived chroot types: Replace print_details with
	get_details.

	* sbuild/sbuild-chroot.cc
	(get_details): New method to insert the chroot details into a
	format_detail object.
	(print_details): Create, fill and output a format_detail object.

	* sbuild/sbuild-format-detail.(cc|h): Change the class from a
	simple formatting wrapper into a container of key-value pairs for
	formatting.  This uses wide stringstreams to align the output for
	translated UTF-8 text.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-util.cc (widen_string, narrow_string): Fix bug in
	conditional which could cause an infinite loop in the C locale.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-format-detail.h: Use a wide string to get
	consistent alignment when using a UTF-8 locale.

	* sbuild/sbuild-util.cc
	(widen_string): New function.  Convert a narrow string to a wide
	string.
	(narrow_string): New function.  Convert a wide string to a narrow
	string.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* README: Add dchroot and dchroot-dsa.

	* schroot/schroot.1.in: Add troubleshooting section.

	* dchroot/dchroot.1.in: Add troubleshooting section.

	* dchroot-dsa/dchroot-dsa.1.in: Add troubleshooting section.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #374713 and #374887.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.cc
	(run_chroot): Log error and exit with failure status if run_child
	throws an exception.
	(run_child): Throw exception on failure, rather than exiting,
	which simplifies the error handling.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* dchroot/Makefile.am (libdchroot_la_SOURCES): Add
	dchroot-main-base.(cc|h).

	* dchroot-dsa/dchroot-dsa-main.(cc|h): Derive from
	dchroot::main_base, and remove functionality shared with dchroot
	contained in main_base.

	* dchroot/dchroot-main.(cc|h):  Derive from main_base, and remove
	functionality shared with dchroot-dsa contained in main_base.

	* dchroot/dchroot-main-base.(cc|h): New files.  A class containing
	functionality common to the main class of dchroot and dchroot-dsa.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-chroot-config.(cc|h): Fix typos.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* sbuild/sbuild-session.(cc|h): Use error codes for logging in
	addition to thrown exceptions.

	* sbuild/sbuild-chroot-config.(cc|h): Use error codes for logging
	in addition to thrown exceptions.

2006-06-24  Roger Leigh  <rleigh@debian.org>

	* Move sbuild sources into an sbuild subdirectory, dchroot sources
	into a dchroot subdirectory and dchroot-dsa sources into a
	dchroot-dsa subdirectory.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* The include order of all includes has been reviewed.  Local
	headers are included first to detect missing includes.  C++
	headers are used instead of C headers.

	* All sources include only the headers they need, rather than
	using sbuild.h.

	* schroot/sbuild.h: Remove.

	* schroot/sbuild-types.h: date operator << uses "%b" rather than
	"%B" in the date format string.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document dchroot compatibility fixes.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-main.cc, schroot/schroot-listmounts.cc,
	schroot/schroot-releaselock.cc: Add date to version output.

	* schroot/sbuild-types.h: Define a date class to format dates for
	output.

	* bootstrap: Generate m4/schroot_release.m4 with a unix time.

	* scripts/schroot_release.m4.in: Define RELEASE_DATE as a unix
	time.

	* debian/changelog: Update rules.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* test/Makefile.am
	(TESTS): Remove sbuild-lock, because it can fail randomly on slow
	or heavily loaded systems due to timing constraints.

	* bootstrap: Create m4 directory if it doesn't exist.

	* Makefile.am
	(dist-hook): Remove junk from distdir such as temorary files.
	(EXTRA_DIST): Distribute bootstrap and m4 macros and templates.

	* configure.ac: Add checks for find and xargs.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* API documentation additions.

	* Add @RELEASE_DATE@ in place of hard-coded date in all manual
	pages.

	* configure.ac: Use SCHROOT_RELEASE_DATE.

	* bootstrap: Generate autoconf macro with embedded release date.

	* scripts/schroot_release.m4.in: New file.  Autoconf macro
	template to define release date.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Add new files.  Additionally, build
	schroot.la and dchroot.la static libraries to ease linking.

	* schroot/dchroot-options.cc, schroot/dchroot-dsa-options.cc,
	schroot/schroot-options.cc: Remove compatibility setup.

	* schroot/schroot-options-base.(cc|h): Remove compatibility_type
	and compat member.

	* schroot/dchroot-main.(cc|h), schroot/dchroot-dsa-main.(cc|h):
	New files.  These two classes derive from schroot::main, and
	override its virtual methods to customise it for dchroot and
	dchroot-dsa respectively.

	* schroot/schroot-main.(cc|h): New files.  This new class contains
	all the functionality of schroot.cc, but is separated into
	separate methods, which may be overridden in other
	implementations.

	* dchroot.cc, dchroot-dsa.cc, schroot.cc: These files (two new)
	are stubs to instantiate an appropriate main object and run it.

	* schroot.cc: Move all functionality into schroot-main.cc.

	* schroot/schroot.cc, schroot/schroot-listmounts.cc,
	schroot/schroot-releaselock.cc (main): Don't disable debugging
	messages if debugging is disabled.  It defaults to disabled
	anyway, and this prevents --debug from working.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): When running dchroot-dsa, use
	dchroot_dsa::chroot_config instead or dchroot::chroot_config.

	* schroot/dchroot-chroot-config.(cc|h): New class.  Remove
	dchroot-dsa specific parts.

	* schroot/dchroot-dsa-chroot-config.(cc|h): New class.  Split
	dchroot-dsa specific parts from dchroot::chroot_config.

2006-06-23  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Build with new headers.

	* schroot/dchroot-session.h: Update API documentation.

	* schroot/schroot.cc: Include the new options headers.  The
	options object is now a tr1::shared_ptr to the base_options
	options base class.

	* schroot/dchroot-dsa-options.(cc|h): dchroot-dsa-specific options
	and parsing logic.

	* schroot/dchroot-options.(cc|h): dchroot-specific options and
	parsing logic.

	* schroot/schroot-options.(cc|h): schroot-specific options and
	parsing logic.

	* schroot/schroot-options-base.(cc|h): New files.  Base class
	containing generic options parsing functionality and common
	options.

2006-06-22  Roger Leigh  <rleigh@debian.org>

	* Update API reference.

2006-06-22  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in, schroot/dchroot.1.in,
	schroot/dchroot-dsa.1.in: Document differences in command
	arguments and chdir behaviour.

2006-06-22  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc: Add a --debug option to enable
	debugging messages.

	* schroot/Makefile.am
	(dchroot_SOURCES): Add dchroot-session-base.(cc|h).
	(dchroot_dsa_SOURCES): Add dchroot-session-base.(cc|h).  Use
	dchroot-dsa-session.(cc|h) instead of dchroot-session.(cc|h).

	* schroot/dchroot-dsa-session.(cc|h): New class, based upon
	dchroot::session and derived from dchroot::session_base.  Remove
	specialisations for dchroot.

	* schroot/dchroot-session.(cc|h): Derive from
	dchroot::session_base.  Remove specialisations for dchroot-dsa.

	* schroot/dchroot-session-base.(cc|h): New class, split from
	dchroot::session.  It includes functionality common to dchroot and
	dchroot-dsa sessions, as well as recording a compatibility state
	which influences session behaviour depending on whether
	dchroot.conf or schroot.conf are used.

	* schroot/schroot.cc: When building for dchroot-dsa, include the
	dchroot-dsa-session.h header.
	(main): When building for dchroot-dsa, create a
	dchroot_dsa::session session.  dchroot-dsa and dchroot sessions
	include a compatibility mode as a fifth argument.

	* schroot/sbuild-session.cc
	(get_login_command, get_user_command): Split the two parts of
	get_command into separate protected virtual methods, so that they
	may be independently overridden and chained up to by derived
	session types.
	(run_child): When reporting an exec error, use filename rather
	than argv[0], which may differ for login shells.

2006-06-22  Luk Claes  <luk@debian.org>

	* po/vi.po: Update Vietnamese translation.

2006-06-22  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc: dchroot and dchroot-dsa only permit
	a single command option.

	* schroot/dchroot-session.cc
	(get_login_directories): New virtual method.  For dchroot, use the
	home directory and then / if not preserving the environment,
	otherwise use the current working directory and /.  For
	dchroot-dsa, always use the home directory and then /.
	(get_command_directories): New virtual method.  This simply wraps
	get_login_directories; dchroot and dchroot-dsa do not distinguish
	between these two use cases.
	(get_command): When running a login shell, this behaves similarly
	to sbuild::session::get_command.  When running a command, dchroot
	runs "sh -c command", and dchroot-dsa runs "command".

	* schroot/sbuild-session.cc
	(getcwd): New utility function, split out from run_child.
	(get_login_directories): New protected virtual method.  Get a list
	of directories to use (including fallbacks) when running a login
	shell.  Use the current working directory, $HOME, passwd pw_dir
	and / in that order.
	(get_command_directories): New protected virtual method.  Get a
	list of directories to use (including fallbacks) when running a
	command.  This is currently only the current working directory;
	there are no fallbacks.
	(get_shell): New protected virtual method.  Get the program to run
	as a shell, falling back to /bin/sh if unavailable.
	(get_command): New protected virtual method.  Get the parameters
	for calling exec with (file and argv).
	(run_child): Use the new functions and methods getcwd,
	get_login_directories, get_command_directories, get_shell and
	get_command.  Handle directory fallbacks when changing directory
	inside the chroot.
	(run_chroot): If debugging is enabled, automatically set the debug
	level to DEBUG_NOTICE.

	* schroot/sbuild-session.h (sbuild): New protected member cwd, to
	hold the current directory before entering the chroot.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-file.h: Remove dangerous TODO item.

	* schroot/sbuild-keyfile.h: Remove completed TODO item.

	* NEWS: Document dchroot-dsa and new user access controls.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (program_name): For safety, return a string
	if the enum is invalid.

	* schroot/sbuild-chroot-config.cc, schroot/sbuild-parse-error.cc:
	Reindent and capitalise translatable error strings.

	* schroot/sbuild-chroot.cc, schroot/sbuild-chroot-source.cc,
	schroot/schroot-options.cc, schroot/schroot-listmounts-options.cc
	schroot/schroot-releaselock-options.cc: Remove whitespace from
	translatable strings.

	* schroot/sbuild-format-detail.h: Ensure that some whitespace
	always separates name and value, even when the name is over 21
	characters.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document users and root-users.

	* schroot/schroot.conf.5.in: Document "users", "root-users",
	"source-users" and "source-root-users" keys.

	* schroot/schroot.cc (main): Fix generated schroot.conf header to
	document users and root-users.

	* schroot/dchroot-session.cc (get_chroot_auth_status): New method
	to replace get_auth_status.  This overrides the sbuild::session
	implementation to provide the correct authorisation checks for
	dchroot and dchroot-dsa.

	* schroot/dchroot-chroot-config.cc (parse_data): Set users rather
	than groups for dchroot-dsa allowed user list.

	* schroot/sbuild-chroot-source.cc: Save and restore source-users
	and source-root-users keyfile keys.

	* schroot/sbuild-chroot-source.h: Add source_users and
	source_root_users members and methods.

	* schroot/sbuild-chroot.cc: Save and restore source-users
	and source-root-users keyfile keys.

	* schroot/sbuild-chroot.h: Add users and root_users members and
	methods.

	* schroot/sbuild-session.cc (get_chroot_auth_status): New
	protected virtual function.  The chroot authorisation checks have
	been split out from get_auth_status for reuse in derived classes.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Install dchroot-dsa setuid root.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Add dchroot-dsa package.

2006-06-21  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Define and substiture DCHROOT_CONF.  Generate
	dchroot-dsa man page.

	* schroot/Makefile.am: Add dchroot-dsa man page.

	* schroot/dchroot-dsa.1.in: New file.  Document dchroot-dsa.

	* schroot/dchroot.1.in: Update documentation now dchroot is the
	official dchroot package, and fix up minor formatting errors.
	Document the --chroot option.  Use @DCHROOT_CONF@ in place of
	/etc/dchroot.conf.

	* schroot/schroot.cc: Don't hard-code DCHROOT_CONF.
	(program_name): New function to get program name.
	(print_version): Use program_name.
	(main): Use new options::compat.  Add support for dchroot-dsa.

	* schroot/dchroot-chroot-config.cc
	(parse_data): When used by dchroot-dsa, extend the available
	whitespace characters to " \t:;,", parse the third field as a user
	list, and add to the chroot group list.  dchroot-dsa chroots don't
	set the "default" chroot alias.

	* schroot/dchroot-session.cc
	(get_auth_status): Add user checks for dchroot-dsa.

	* schroot/schroot-options.cc: Use compat to adapt to selected
	compatibility mode, in place of dchroot_compat.  Add
	specialisations for dchroot-dsa.

	* schroot/schroot-options.h: Add compatibility_type enum
	(for schroot, dchroot and dchroot-dsa).  Add compat member to
	store current compatibility mode, in place of dchroot_compat.

	* schroot/sbuild-session.h: get_config returns a const reference.

	* test/sbuild-util.cc: Update test for split_string.

	* schroot/sbuild-keyfile.h: Use new split_string argument type.

	* schroot/sbuild-util.h: split_string uses a string as a list of
	separators, instead of a single character.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Add rules for dchroot-dsa.

	* configure.ac: Add enable option for dchroot-dsa.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* Update translations.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-error.h: Remove runtime_error_custom.

	* schroot/sbuild-custom-error.h: Add virtual destructor.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth-conv.h: Remove error typedef.

	* schroot/sbuild-auth-conv-tty.(cc|h): Use the custom_error
	exception class.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-custom-error.tcc (format_error): detail and error
	arguments were used in the wrong order in the two argument case.

	* schroot/dchroot-chroot-config.cc (parse_data): Use the
	parse_error class.

	* schroot/sbuild-chroot-config.(cc|h): Use the custom_error
	exception class.  Merge check_security with load_data.
	(load_data): Report filename when throwing a parse error.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-personality.(cc|h): Use the custom_error
	exception class.

2006-06-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.h: Reindent error codes.

	* schroot/sbuild-lock.(cc|h): Use the custom_error exception
	class.

2006-06-19  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.(cc|h), schroot/sbuild-chroot-file.cc,
	schroot/sbuild-chroot-block-device.cc,
	schroot/sbuild-chroot-lvm-snapshot.cc: Use the custom_error
	exception class.

2006-06-19  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.(cc|h), schroot/sbuild-session.(cc|h),
	schroot/dchroot-session.cc (run_impl): Use new templated exception
	type.

	* schroot/sbuild-session-error.(cc|h): Remove.

	* schroot/sbuild-auth-error.(cc|h): Remove.

	* schroot/sbuild-custom-error.(cc|h): New files, providing an
	exception class templated on an error code enum.  It replaces the
	auth_error and session_error exception classes.

2006-06-19  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot-session.cc (run_impl): Throw a session_error in
	place of a runtime_error_custom.

	* schroot/sbuild-session.cc: Throw a session_error in place of a
	runtime_error_custom.  Correct capitalisation of error messages.
	Don't throw an exception when a child exits with a nonzero exit
	status.

	* schroot/sbuild-session.h: Use session_error as the error type.

	* schroot/sbuild-auth.cc: Throw an auth_error in place of a
	runtime_error_custom.
	(pam_strerror): New private method to get a PAM error message.

	* schroot/sbuild-auth.h: Use auth_error as the error type.

	* schroot/Makefile.am: Add sbuild-auth-error.(cc|h) and
	sbuild-session-error.(cc|h).

	* schroot/sbuild-session-error.(cc|h): New files, providing an
	exception class for reporting session errors.

	* schroot/sbuild-auth-error.(cc|h): New files, providing an
	exception class for reporting authentication errors.

2006-06-19  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/00check: Make sanity check errors more
	descriptive.  Fix check for using / as a chroot location.

2006-06-19  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/10mount: Only remove the mount location if it
	exists (to quell a warning).

2006-06-18  Luk Claes  <luk@debian.org>

	* po/sv.po: Update Swedish translation.

2006-06-17  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.99.1.

	* NEWS: Bump version to 0.99.1.

	* configure.ac: Bump version to 0.99.1.

2006-06-17  Roger Leigh  <rleigh@debian.org>

	* Version 0.99.0.

	* debian/changelog: Finalise for 0.99.0.

	* NEWS: Document init script changes.

2006-06-17  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Tidy up changes for release.

	* debian/schroot.postinst: If upgrading from a version less than
	0.99.0-1, remove the rc.d symlinks, because rcS is used instead of
	the normal runlevels.

2006-06-17  Roger Leigh  <rleigh@debian.org>

	* debian/control: Add Luk Claes as a co-maintainer.

2006-06-17  Roger Leigh  <rleigh@debian.org>

	* debian/schroot.README.Debian: Move from debian/README.Debian.
	Remove outdated dchroot bits.

	* debian/schroot.NEWS: New file.  Document the splitting out of
	dchroot.

2006-06-16  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Remove command-prefix example of
	using linux32, now that the personality option is the recommended
	method of changing personality.

2006-06-15  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update British English translation.

2006-06-15  Roger Leigh  <rleigh@debian.org>

	* po/POTFILES.in: Update list of source files.  Remove all
	headers.

2006-06-15  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed items (translatable strings removed from
	headers, and root no longer needs to be in groups or root groups).

	* schroot/Makefile.am: Add sbuild-format-detail.cc.

	* schroot/sbuild-format-detail.h: Remove ostream operator <<
	format_detail<bool> specialisation.

	* schroot/sbuild-format-detail.cc: New file.  Move ostream
	operator << format_detail<bool> specialisation from the headers,
	so translatable strings are not used in the header.

2006-06-15  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Add sbuild-parse-error.(cc|h).

	* schroot/sbuild-keyfile.cc (keyfile, check_priority) Use
	parse_error instead of runtime_error_custom for throwing on parse
	failures.

	* schroot/sbuild-keyfile.h: Use parse_error instead of
	runtime_error_custom for throwing on parse failures, and also for
	logging warnings.  Additionally, be stricter when parsing by
	throwing a parse error when an empty group is specified, or a key
	before a group definition.

	* schroot/sbuild-parse-value.h: Throw a parse_error when parsing
	fails.

	* schroot/sbuild-parse-error.(cc|h): New files, providing an
	exception class for reporting parse errors.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-personality.cc
	(personality): On Linux, default to initialising with the current
	process' personality, otherwise initialise to "undefined".
	(get_name): New method.  Return the current personality.

	* schroot/sbuild-personality.h: Document constructors fully, and
	add a get method to get the personality type.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: dchroot doesn't need to Replace schroot.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot.1.in: Document incompatibilities with DSA
	dchroot, and a few minor cleanups.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* Update translations.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Split dchroot into a separate package.

2006-06-14  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): Output configuration file with a help
	message in comments, to help migrating dchroot.conf.

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am
	(install-data-hook): Don't create $(SCHROOT_LOCK_DIR).

	* configure.ac: Remove SCHROOT_LOCK_DIR, which is no longer used
	now we use lockdev and fcntl locking.

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #372874.

	* NEWS: Document dchroot.conf change.

	* schroot/dchroot.1.in: Document the new personality field in
	dchroot.conf.

	* schroot/dchroot-chroot-config.cc (parse_data): Parse a third
	optional "personality" field, and if present, set the chroot
	personality.

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #372569.

	* NEWS: Document changed authorisation behaviour.

	* schroot/sbuild-session.cc
	(get_auth_status): If no groups are specified, root can still gain
	access (but still requires authentication).

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #354344.

	* schroot/setup/10mount: Mount plain chroots with --rbind rather
	than --bind.  This is safe now schroot-listmounts is used to
	unmount all filesystems in the chroot.

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* THANKS: New file.  Add Ben Hutchings.

2006-06-13  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document new "personality" option.

	* po/POTFILES.in: Add schroot/sbuild-personality.(cc|h).

	* test/Makefile.am: Add sbuild-personality.cc.

	* test/sbuild-personality.cc: Tests for sbuild::personality.

	* schroot/schroot.conf.5.in: Document new "personality" key.

	* schroot/Makefile.am: Add sbuild-personality.(cc|h).

	* schroot/sbuild.h: Include sbuild-personality.h.

	* schroot/sbuild-session.cc (run_child): Set the personality
	before chrooting.

	* schroot/sbuild-chroot.cc:
	(chroot) When constructing a chroot, the persona defaults to
	"linux" on Linux systems, and "undefined" on all other systems.
	(get_persona): New method to get the persona.
	(set_persona): New method to set the persona.
	(print_details): Print the persona.
	(get_keyfile): Set "personality" key.
	(set_keyfile): Get "personality" key.

	* schroot/sbuild-chroot.h: Include personality as a persona
	member, and provide a getter and setter for it.

	* schroot/sbuild-personality.(cc|h): New files.  This is a class
	wrapping the functionality of personality(2) for changing the
	process execution domain.  It includes a mapping from names to
	personality enumarations, to allow user specification of
	personalities.

2006-06-12  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.99.0.

	* NEWS: Bump version to 0.99.0.

	* configure.ac: Bump version to 0.99.0.

2006-06-10  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.11.

	* debian/changelog: Update for 0.2.11.

2006-06-10  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-listmounts-options.h
	(schroot_listmounts): Fix typo.

2006-06-10  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Don't package libsbuild.la.

	* schroot/Makefile.am (noinst_LTLIBRARIES): Do not install
	libsbuild.la.

2006-06-10  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document that scripts may now fail.

	* schroot/schroot-setup.5.in: Document that scripts must be
	idempotent.

2006-06-09  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update translation.

	* po/POTFILES.in: Add schroot-listmounts sources.

	* debian/changelog: Close #369626.

	* NEWS: Document 05file and 10mount changes.

	* schroot/setup/05file: Use schroot-listmounts to check if there
	are any mounted filesystems before purging the chroot.

	* schroot/setup/10mount: Use schroot-listmounts to unmount all
	filesystems in a chroot.  Exit with an error if unmounting fails.

	* test/sbuild-chroot.cc: Implement the new form of
	sbuild::chroot::setup_lock().

	* schroot/schroot-listmounts-options.(cc|h): New files.  These are
	the command-line option parser for schroot-listmounts.

	* schroot/schroot-listmounts.cc: New file.  This is a program to
	list all of the mounts under a given mountpoint.

	* schroot/sbuild-session.cc (setup_chroot): Use the chroot lock
	and unlock methods, in place of setup_lock.

	* schroot/sbuild-chroot-plain.cc, schroot/sbuild-chroot-file.cc,
	schroot/sbuild-chroot-block-device.cc,
	schroot/sbuild-chroot-lvm-snapshot.cc: setup_lock only removes the
	session (using setup_session_info) if the setup scripts succeeded.

	* schroot/sbuild-chroot-plain.h, schroot/sbuild-chroot-file.h,
	schroot/sbuild-chroot-block-device.h,
	schroot/sbuild-chroot-lvm-snapshot.h: setup_lock is protected and
	has an additional status argument.

	* schroot/sbuild-chroot.cc
	(lock): New function; calls setup_lock.
	(unlock): New function; calls setup_lock.

	* schroot/sbuild-chroot.h: Replace setup_lock with lock and unlock
	methods.  Unlock takes a status argument which indicates if the
	setup scripts failed or not.  setup_lock is now a protected
	virtual method used by lock and unlock.

2006-06-08  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #369633.

	* AUTHORS: Add Andreas Bombe.

	* schroot/schroot.conf.5.in: Correct typo.

	* schroot/schroot.1.in: Correct ambiguity and mistakes in the
	documentation relating to specifying session IDs.

2006-05-27  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/control (Standards-Version): Update to 3.7.2.

2006-05-27  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.2.11.

	* NEWS: Bump version to 0.2.11.

	* configure.ac: Bump version to 0.2.11.

2006-05-27  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.10.

	* debian/changelog: Update for 0.2.10.

2006-05-27  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/50chrootname: Strip session UUID when writing
	/etc/debian_chroot.

2006-05-15  Roger Leigh  <rleigh@debian.org>

	* po/sv.po: Updated translated from the Free Translation Project.

2006-05-14  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.cc (add): If a chroot alias is the
	same as the chroot name, don't warn about it, because the effect
	is still unambiguous.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* Remove unused .cvsignore files.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc: Update documentation.

	* schroot/schroot-releaselock.cc: Update documentation.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* debian/control (Standards-Version): Upgrade to 3.7.0.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Bump version to 0.2.10.

	* NEWS: Bump version to 0.2.10.

	* debian/changelog: Bump version to 0.2.10-1.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* Makefile.am (dist-hook): Don't distribute .svn directories.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.9.

	* debian/changelog: Update for 0.2.9.

	* po/en_GB.po: Updated British English translation.

	* README: Document new compiler requirements.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document directory behaviour.

	* schroot/sbuild-session.cc (run_child): If the current working
	directory does not exist inside the chroot, change to the home
	directory (for login shells), or fail with an error (for commands)
	where the behaviour must be deterministic.

2006-04-30  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-parse-value.cc: Update tests.

	* schroot/sbuild-keyfile.h (get_value): Catch exceptions thrown by
	parse errors and log a warning.

	* schroot/sbuild-environment.h (get): Catch exceptions thrown by
	parse errors and log a warning.

	* schroot/sbuild-parse-value.cc (parse_value): Add class
	constructor and destructor.
	(parse): Parse functions use this->value rather than a string
	value argument.

	* schroot/sbuild-parse-value.h: Move parse_value functions into
	the generic_value class as private parse methods; the string value
	is taken directly from this->value, rather than passed as an
	argument.  generic_value class renamed to parse_value.  On parse
	failure, an exception is thrown.

2006-04-29  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-keyfile.h: Update documentation.

2006-04-29  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed file repack item.

2006-04-29  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-chroot-file.cc (chroot_file>): Check for
	CHROOT_FILE_REPACK in the environment.

2006-04-29  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document GCC portability.

	* test/Makefile.am (AM_CXXFLAGS): Remove -Wextra, for GCC 3.3/3.4
	portability.

	* schroot/sbuild-chroot-config.cc (load_data): Construct
	__gnu_cxx::stdio_filebuf appropriately, depending on the required
	construction semantics.

	* schroot/sbuild-chroot.cc (setup_session_info): Construct
	__gnu_cxx::stdio_filebuf appropriately, depending on the required
	construction semantics.

	* configure.ac: Check whether the old (GCC < 3.4) or new (GCC >=
	3.4) __gnu_cxx::stdio_filebuf construction semantics are required,
	for portability to older GCC versions.

2006-04-26  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/10mount (do_mount) : Create directories for
	mounting filesystems onto if they don't exist.

2006-04-26  Roger Leigh  <rleigh@debian.org>

	* po/POTFILES.in: Add schroot/sbuild-format-detail.h

2006-04-26  Roger Leigh  <rleigh@debian.org>

	* GCC 4.2 compatibility fixes.

	* test/sbuild-keyfile.cc (test_set_value): Use iterator ranges,
	rather than whole containers, when calling
	keyfile::set_list_value.

	* schroot/sbuild-chroot-source.cc
	(get_keyfile): Use iterator ranges, rather than whole containers,
	when calling keyfile::set_list_value.
	(set_keyfile): Reindent.

	* schroot/sbuild-chroot.cc
	(get_keyfile): Use iterator ranges, rather than whole containers,
	when calling keyfile::set_list_value.
	(set_keyfile): Reindent.

	* schroot/sbuild-keyfile.h
	(get_list_value): Templated on container type only; the value_type
	is no longer a template parameter.  generic_value is used for the
	type conversion.
	(set_list_value: A range specified by iterators is used, rather
	than the whole container.

	* schroot/sbuild-parse-value.h: Add a new generic_value class to
	wrap type conversions from strings.

	* schroot/sbuild-format-detail.h: Move templated operator<<
	methods outside the class definition.  Make format_details inline.

2006-04-08  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am
	(sbuild_public_h_sources): Add sbuild-format-detail.h

	* schroot/sbuild.h: Include sbuild-format-detail.h.

	* schroot/sbuild-chroot.h: Remove sbuild::chroot::format_detail.

	* schroot/sbuild-format-detail.h: New class,
	sbuild::format_detail, moved from sbuild::chroot::format_detail.

2006-04-08  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-keyfile.h: Use Boost if TR1 is not available.

	* schroot/sbuild-chroot.h: Use Boost if TR1 is not available.

	* schroot/sbuild-auth.h: Use Boost if TR1 is not available.

	* schroot/Makefile.am:
	(AM_CXXFLAGS): Remove -Wextra.
	(BUILT_SOURCES): Don't build sbuild.gch.
	(#CLEANFILES): Don't clean sbuild.gch.
	(nodist_libsbuild_la_SOURCES): Add sbuild-config.h.

	* configure.ac: Add a new header, schroot/sbuild-config.h.  Add
	header checks for tr1/memory, boost/shared_ptr.hpp, tr1/tuple and
	boost/tuple/tuple.hpp.

2006-04-07  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #361108.

	* debian/README.Debian: Move chroot safety advice to README.

2006-04-07  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Bump version to 0.2.9.

	* NEWS: Bump version to 0.2.9.

	* debian/changelog: Bump version to 0.2.9-1.

2006-04-07  Roger Leigh  <rleigh@debian.org>

	* po/vi.po: Update.

2006-03-19  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.8.

	* debian/changelog: Update for 0.2.8.

2006-03-18  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Bump version to 0.2.8.

	* NEWS: Bump version to 0.2.8.

	* debian/changelog: Bump version to 0.2.8-1.

2006-03-18  Roger Leigh  <rleigh@debian.org>

	* po/vi.po: Update.

	* po/sv.po: Update.

2006-03-18  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc (run_child): Don't fix up argv for a
	login shell if using a command-prefix, since this will not be a
	valid command for command-prefix to execute.

2006-03-08  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Version 0.2.7-2, released to fix a dchroot
	crash.

	* schroot/dchroot-session.cc
	(run_impl): Correctly chain up to the base class.

2006-03-08  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.7.

	* debian/changelog: Update for 0.2.7.

	* NEWS: Update for 0.2.7.

2006-03-07  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.2.7.

	* NEWS: Bump version to 0.2.7.

	* configure.ac: Bump version to 0.2.7.

	* po/en_GB.po: Update translation.

	* schroot/sbuild-auth.cc
	(setupenv): For security, PATH is always set to a sane state for
	root, but only set in other cases if not preserving the
	environment.

	* schroot/sbuild-session.cc
	(run_child): When "command-prefix" has been specified, correctly
	set the filename to pass to execve.  Mark four strings for
	translation.

2006-03-06  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.6.

	* debian/changelog: Update for 0.2.6.

2006-03-06  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update translation.

2006-03-06  Roger Leigh  <rleigh@debian.org>

	* TODO: Update.

	* schroot/schroot.conf.5.in: Document required ownership and
	permissions for file archives.

	* schroot/sbuild-chroot-file.cc
	(setup_lock): Check ownership and permissions of file archive.

	* schroot/sbuild-chroot-config.cc (check_security): Tidy error
	message formatting.

	* schroot/setup/10mount:
	(do_umount): Only umount if the mountpoint exists.

	* schroot/setup/05file:
	(repack_file): Preserve ownership and permissions of the original
	archive file.

2006-03-06  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document environment sanitising.

	* schroot/schroot.cc
	(main): Allow the environment to be preserved even if changing
	users.

	* schroot/sbuild-auth.cc
	(setupenv): Add SHELL to default environment.  Sanitise the
	environment by removing dangerous variables (the same set used by
	sudo).

2006-03-06  Roger Leigh  <rleigh@debian.org>

	* po/sv.po: Updated translated from the Free Translation Project.

2006-03-02  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Close #354780.

	* schroot/setup/05file: If the chroot status is not "ok", don't
	repack the file archive.

	* schroot/schroot-setup.5.in: Document second argument to setup
	and exec scripts (chroot status).

	* schroot/schroot.cc (main): Save and restore termios, so that
	abnormal session termination leaves the terminal in a usable
	state.

	* schroot/sbuild-session.cc
	(sighup_called): New variable to flag SIGHUP.
	(sighup_handler): New function to handle SIGHUP.
	(run_impl): Enable and disable handler for SIGHUP.  Switch
	chroot::SETUP_STOP action to after the catch block, to prevent it
	being run twice on failure.
	(setup_chroot): Set chroot_status to false on failure.  Use this
	as the second argument to setup and exec scripts.  If chroot
	locking fails, immediately unlock to ensure that any session
	metadata files are unlinked.
	(wait_for_child): If SIGHUP is caught, kill any child process and
	throw an error.
	(set_sighup_handler): Set a handler for SIGHUP.
	(clear_sighup_handler): Restore the previous handler for SIGHUP.

	* schroot/sbuild-session.h
	(chroot_status): New member to track the state of the chroot.
	(saved_signals): New member used to save and restore signals
	handlers.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document new source chroots and file repacking.

	* schroot/schroot-setup.5.in: Document CHROOT_FILE_REPACK.

	* schroot/schroot.conf.5.in: Document source chroot options.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/05file:
	(unpack_file): Use a temporary file to prevent data loss, and use
	trap to clean up on failure.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/05file:
	(check_filetype): Correctly escape '.'.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/05file: Fix incorrect comment.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/05file: Run check_filetype in all cases.
	(unpack_file): Correctly unpack tar.bz2 files.
	(repack_file): New function to pack up the chroot tree back into
	an archive file.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-environment.h
	(add): Use std::boolalpha to correctly represent boolean values.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/exec/00check: Add check for CHROOT_FILE_REPACK.

	* schroot/setup/00check: Add check for CHROOT_FILE_REPACK.

	* schroot/sbuild-chroot-file.cc:
	(chroot_file): repack member is false by default.
	(clone_source): Create a chroot_block_device source chroot.  Set
	repack to true.
	(setup_env): Chain up to chroot_source method.  Add a
	CHROOT_FILE_REPACK environment variable.
	(print_details): Chain up to chroot_source method.
	(get_keyfile): Chain up to chroot_source method.  Set a
	"file-repack" key.
	(set_keyfile): Chain up to chroot_source method.  Get a
	"file-repack" key, but only when restoring an active session.

	* schroot/sbuild-chroot-file.h: Derive from sbuild::chroot_source,
	 and implement sbuild::chroot_source::clone_source.
	(repack): New member to allow repacking of the chroot on session
	ending.

	* schroot/sbuild-chroot-config.cc (parse_data): Remove unneeded
	dynamic_cast to chroot_lvm_snapshot *.  Make sure source chroot is
	valid before adding it.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.cc
	(parse_data): Remove special case for lvm-snapshot chroots.
	Instead, create and add a source chroot for any inactive chroot
	implementing chroot_source.

	* schroot/sbuild-chroot-lvm-snapshot.cc
	(clone_source): Create a chroot_block_device source chroot.
	(setup_env): Chain up to chroot_source method.
	(print_details): Chain up to chroot_source method.
	(get_keyfile): Chain up to chroot_source method.
	(set_keyfile): Chain up to chroot_source method.

	* schroot/sbuild-chroot-lvm-snapshot.h: Derive from
	sbuild::chroot_source, and implement
	sbuild::chroot_source::clone_source.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* All classes derived from sbuild::chroot use virtual public
	inheritance (to allow for the use of sbuild::chroot_source).

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* Makefile.am: Add sbuild-chroot-source.(cc|h).

	* schroot/sbuild.h: Include sbuild-chroot-source.h.

	* schroot/sbuild-chroot-source.(cc|h): New file.  This is an
	interface class, to be implemented by chroots providing source
	chroots in addition to normal chroots.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/schroot.init: Rename $DAEMON to $SCHROOT.  Don't exit
	with an error if session recovery for an individual chroot fails.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document changed behaviour of session operations.

	* schroot/schroot-options.cc (options): Allow session recovery,
	session running and session ending to be performed upon multiple
	chroots, rather than one at once.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.cc (parse_data): Don't create a
	"-source" chroot for LVM snapshots if the chroot is active.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document exec.d and run-exec-scripts changes.

2006-02-28  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/postinst: Move /etc/schroot/run.d/00check to
	/etc/schroot/exec.d/00check if modified locally.

	* debian/preinst: Remove /etc/schroot/run.d/00check if not
	modified locally.

	* Update tests.

	* schroot/schroot.conf: Rename run-session-scripts to
	run-exec-scripts.

	* schroot/schroot.conf.5.in: Document new configuration
	parameters, and deprecated parameters.

	* schroot/schroot.1.in: Document new setup script locations.

	* schroot/schroot-setup.5.in: Document new setup script locations
	and parameters.

	* schroot/Makefile.am (SUBDIRS): Rename run to exec.

	* configure.ac: Rename SCHROOT_CONF_RUN_D to SCHROOT_CONF_EXEC_D.
	Rename schroot/run/Makefile to schroot/exec/Makefile.  Tidy
	comments.

	* schroot/sbuild-session.cc: Use new chroot functions and enums.
	Also use SCHROOT_CONF_EXEC_D rather than SCHROOT_CONF_RUN_D.
	Execution scripts are called with "exec-start" and "exec-stop",
	rather than "run-start: and "run-stop", respectively.

	* Use new functions and enums in all derived chroot types.

	* schroot/sbuild-chroot.cc
	(get_run_exec_scripts): Rename from get_run_session_scripts.
	(set_run_exec_scripts): Rename from set_run_session_scripts.
	(print_details): Print "Run Execution Scripts" rather than "Run
	Session Scripts".
	(get_keyfile): Set "run-exec-scripts" in the keyfile.
	(set_keyfile): Get "run-exec-scripts" in the keyfile.  Also get
	"run-session-scripts" (now deprecated) for backward compatibility.

	* schroot/sbuild-chroot.h
	(setup_type): Rename RUN_START and RUN_STOP to EXEC_START and
	EXEC_STOP.
	(run_exec_scripts): Rename member from run_session_scripts.

	* Rename schroot/run to schroot/exec.

2006-02-27  Roger Leigh  <rleigh@debian.org>

	* debian/postinst: Move /etc/schroot/run.d/50sbuild to
	/etc/schroot/setup.d/50sbuild if modified locally.

	* debian/preinst: Remove /etc/schroot/run.d/50sbuild if not
	modified locally.

	* schroot/schroot-setup.5.in: Update location of 50sbuild.

	* Move 50sbuild from schroot/run.d to schroot/setup.d.

	* schroot/setup/50sbuild: Move from schroot/run/50sbuild.

2006-02-27  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Bump version to 0.2.6.

2006-02-27  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document "command-prefix" option.

	* schroot/schroot.conf.5.in: Document "command-prefix" option.

	* schroot/sbuild-session.cc
	(run_child): Concatenate command_prefix and command to get the
	command to run in the chroot.

	* schroot/sbuild-chroot.cc
	(get_command_prefix): New method to get command prefix.
	(set_command_prefix): New method to set command prefix.
	(print_details): Display command_prefix if set.
	(get_keyfile): Set command-prefix in keyfile.
	(set_keyfile): Get command-prefix from keyfile.

	* schroot/sbuild-chroot.h: New member command_prefix.

2006-02-27  Roger Leigh  <rleigh@debian.org>

	* Remove bashisms in all setup and run shell scripts (test "-o"
	and "function" in shell functions).  Thanks to Clint Adams for
	this patch.

2006-02-26  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.5.

	* configure.ac: Update for 0.2.5.

	* debian/changelog: Update for 0.2.5.

	* NEWS: Document "Path" line.  Update for 0.2.5.

	* schroot/sbuild-chroot.cc (print_details): Output path
	information if available.

2006-02-26  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update to close the --help options (Bug
	#354477).

2006-02-26  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* schroot/run/50sbuild: Create
	${CHROOT_PATH}/var/lib/sbuild/srcdep-lock and set ownership and
	permissions of all files under ${CHROOT_PATH}/var/lib/sbuild to
	root:sbuild and 02775, respectively.  Thanks to Adeodato Simó for
	this patch.

2006-02-26  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Correct the --help options.  Thanks to
	Clint Adams for this patch.

2006-02-25  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Add acknowledgement for #354257.

2006-02-25  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.4.

	* debian/changelog: Update for 0.2.4.

	* TODO: Update.

2006-02-25  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.h: Fix Doxygen warnings.

	* schroot/sbuild-parse-value.cc: Fix Doxygen warnings.

	* schroot/sbuild-parse-value.h: Fix Doxygen warnings.

2006-02-25  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* NEWS: Update.

	* Update tests.

	* schroot/schroot.conf.5.in: Document "run-setup-scripts"
	behaviour for plain chroots.

	* schroot/setup/10mount: Allow plain chroots to run the mount
	script.  For plain chroots, bind mount LOCATION on MOUNT_LOCATION.

	* schroot/setup/00check: For plain chroots, verify
	CHROOT_LOCATION, rather than CHROOT_PATH (because CHROOT_PATH does
	not exist at this point).

	* schroot/sbuild-session.cc
	(run_impl): In addition to all other chroot types, if chroot is a
	chroot_plain chroot with setup scripts enabled, set the mount
	location to the session id.

	* schroot/sbuild-chroot-plain.cc
	(get_path): New virtual method to override base class
	implementation.  When setup scripts are enabled, return the mount
	location, or else the location.
	(setup_lock): When setup scripts are enabled, write out a session
	metadata.
	(get_session_flags): When setup scripts are enabled, enable
	SESSION_CREATE, or else 0.

2006-02-24  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Document "location" for block-device
	chroots.

	* schroot/schroot-setup.5.in: Document CHROOT_LOCATION and
	CHROOT_PATH.

	* Update tests to check CHROOT_LOCATION and CHROOT_PATH.

	* schroot/setup/50chrootname: Replace CHROOT_MOUNT_LOCATION with
	CHROOT_PATH.

	* schroot/setup/30passwd: Replace CHROOT_MOUNT_LOCATION with
	CHROOT_PATH.

	* schroot/setup/20network: Replace CHROOT_MOUNT_LOCATION with
	CHROOT_PATH.

	* schroot/setup/10mount: Replace CHROOT_MOUNT_LOCATION with
	CHROOT_PATH.

	* schroot/setup/00check: Add CHROOT_LOCATION and CHROOT_PATH.
	Replace CHROOT_MOUNT_LOCATION with CHROOT_PATH.

	* schroot/run/50sbuild: Replace CHROOT_MOUNT_LOCATION with
	CHROOT_PATH.

	* schroot/run/00check: Add CHROOT_LOCATION and CHROOT_PATH.

	* schroot/sbuild-chroot-config.cc
	(print_chroot_location): Use get_path() instead of
	get_mount_location().

	* schroot/sbuild-session.cc
	(run_child): Use get_path() instead of get_mount_location().

	* schroot/sbuild-chroot-plain.cc
	(get_location): Chain up to base class implementation.
	(set_location): Chain up to base class implementation.
	(print_details): Remove printing of location detail.

	* schroot/sbuild-chroot-plain.h
	(get_location): Make virtual.
	(set_location): Make virtual.
	(get_mount_location): Remove virtual function.
	(location): Remove member.

	* schroot/sbuild-chroot-block-device.cc
	(get_location): New method.  Get the location of a chroot on the
	device filesystem.
	(set_location): New method.  Set the location of a chroot on the
	device filesystem.
	(get_keyfile): Set location in keyfile.
	(set_keyfile): Get optional location from keyfile.

	* schroot/sbuild-chroot.cc
	(get_location): New virtual method.
	(set_location): New virtual method.
	(get_path): New virtual method.  The default implementation
	concatenates and returns the mount_location and the location.
	(setup_env): Add CHROOT_LOCATION and CHROOT_PATH to the
	environment.
	(print_details): print Location and Path.

	* schroot/sbuild-chroot.h:
	(location): New member.

2006-02-24  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Add missing space.

2006-02-24  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.2.4.

	* NEWS: Bump version to 0.2.4.

	* configure.ac: Bump version to 0.2.4.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Fix typo.

	* schroot/dchroot.1.in: Fix syntax error.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Install dchroot setuid.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update

	* debian/rules: dchroot must be installed setuid root.

	* debian/schroot.lintian-overrides: Add dchroot.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.3.

	* debian/changelog: Update for 0.2.3.

	* NEWS: Document changed "--info" output.

	* TODO: Update.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.cc (print_details): Add a "Session
	Managed" line if SESSION_CREATE is used.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-chroot-config.cc: Account for additional -source
	chroots.

2006-02-21  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document automatic block-device creation for lvm-snapshot
	chroots.

	* TODO: Remove completed item.

	* schroot/schroot.conf.5.in: Document automatic block-device
	creation for lvm-snapshot chroots.

	* schroot/sbuild-chroot-config.cc (parse_data): Create a
	corresponding block-device chroot for each lvm-snapshot chroot.
	"-source" is appended to the chroot name and its aliases.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot.1.in: Document how to remove dchroot.conf.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot.1.in: Document reasons why schroot.conf should
	be used in preference to dchroot.conf.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot-session.cc (run_impl): Use boost::format rather
	than printf specifiers.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* Update po files.

	* po/POTFILES.in: Add dchroot files.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* .cvsignore: Update for dchroot.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): Use ACTION_LOCATION, not
	ACTION_INFO_LOCATION.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update for version 0.2.3-1.

	* debian/README.Debian: Update dchroot notes.

	* debian/rules (config.status): Add --enable-dchroot to configure,
	to package the dchroot + wrapper.

	* debian/control (schroot): Provide, Conflict and Replace dchroot.
	Enhances sbuild.  Suggest lvm-common for LVM support.  Update
	description.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* NEWS: Add dchroot.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document new --location option.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* TODO: Add dchroot.

	* configure.ac: Create schroot/dchroot.1.

	* schroot/Makefile.am: If --enable-dchroot was used, build and
	install dchroot and dchroot.1.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.h (session): The contructor chroots
	argument is a const reference rather than a value.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot.1.in: Add manual page for dchroot.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc: If SBUILD_DCHROOT_COMPAT is defined, run in
	dchroot compatibility mode, using the alternate
	dchroot::chroot_config and dchroot::session classes for reading
	the configuration and session handling.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc
	(options): Set dchroot_compat if SBUILD_DCHROOT_COMPAT is defined.
	(options): If dchroot_compat is set, use dchroot compatible
	options, otherwise schroot options.

	* schroot/schroot-options.h
	(action_type): New action ACTION_LOCATION to print chroot
	location.
	(chroot_path): New member; chroot to print path.
	(dchroot_compat): New member; dchroot compatibility mode.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/dchroot-session.(cc|h): New class, dchroot::session,
	derived from sbuild::session.  This disables user authentication
	(but not authorisation), and disables user switching.

	* schroot/dchroot-chroot-config.(cc|h): New class,
	dchroot::chroot_config, derived from sbuild::chroot_config.  This
	parses the dchroot.conf configuration file.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Add --enable-dchroot check to enable dchroot
	compatibility.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): Use the new session::ptr typedef.

	* schroot/sbuild-session.h: Add a ptr typedef, a shared_ptr to a
	session.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.cc
	(print_chroot_list_simple): New function to print the chroot list
	on a single line, in the same style as dchroot (comma-separated,
	with aliases in square brackets).
	(print_chroot_location): New function to print the mount location
	of the specified chroots.

2006-02-20  Roger Leigh  <rleigh@debian.org>

	* po/Makevars (XGETTEXT_OPTIONS): Add --boost so boost-format
	strings are correctly extracted.

2006-02-18  Roger Leigh  <rleigh@debian.org>

	* Updated sv.po and vi.po from the Free Translation Project.

2006-02-18  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-config.h: Fix include guard naming.

	* schroot/sbuild-chroot-config.cc (add): New overloaded protected
	method to add a chroot, including checking for duplicates.  Split
	out from parse_data.

2006-02-17  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-chroot-config.cc: Update tests.

	* schroot/schroot.cc
	(main): Use new chroot_config typedef, and use chroot_config::add
	instead of add_config_file and add_config_directory.

	* schroot/sbuild-chroot-config.h
	(ptr): New typedef for a shared_ptr to a chroot_config.
	(add_config_file: Now private.
	(add_config_directory): Now private.

	* schroot/sbuild-chroot-config.cc
	(add): New method.  This replaces the file/directory detection in
	the constructor, and then calls add_config_file or
	add_config_directory as required.
	(load_data): New function, renamed from load.
	(parse_data): New virtual function, called from load_data.  This
	parses the loaded data, and is split out from load.

2006-02-16  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): If --quiet is specified, don't log an
	error if the session fails.  A non-zero exit status is still
	returned.

2006-02-16  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc (run_child): If it is not possible to
	change into the correct directory inside the chroot, print a
	warning rather than an error.

2006-02-07  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.2.3.

	* debian/control (Build-Depends): Add pkg-config build dependency.

	* NEWS: Bump version to 0.2.3.

	* configure.ac: Bump version to 0.2.3.

2006-02-07  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-setup.5.in: Document setup/05file.

	* schroot/schroot.1.in: Fix typo in macro.

2006-02-07  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc
	(options): Fix typo (begining).  Thanks to Clytie Siddall at the
	Free Translation Project for spotting it.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.2.

	* debian/changelog: Update for 0.2.2.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Update.

	* po/POTFILES.in: Update file list.

	* Minor cosmetic cleanups.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Remove static qualifer from functions in the unnamed namespace.

	* schroot/sbuild-chroot-config.cc
	(chroot_alphashort): Move to unnamed namespace.

	* Update doxygen documentation for file members.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Use the same indentation style for all function prototypes.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* NEWS: Document updated defaults.

	* schroot/schroot.conf.5.in: Document updated defaults.

	* schroot/sbuild-chroot-lvm-snapshot.cc
	(chroot_lvm_snapshot): Default to running setup and session
	scripts.

	* schroot/sbuild-chroot-file.cc
	(chroot_file): Default to running setup and session scripts.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* debian/control: Add versioned depends on libpam0g-dev >=
	0.79-3.1, because earlier versions have broken headers, due to
	redefining internal glibc/libstdc++ types.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Remove all keyfile constructors from sbuild::chroot and derived
	classes.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* doc/schroot.dox.in: Strip the build directory from file
	pathnames, use built-in STL support, and sort classes by
	namespace.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::chroot::chroot_ptr to sbuild::chroot::ptr,
	sbuild::chroot::SetupType to sbuild::chroot::setup_type, and
	sbuild::chroot::SessionFlags to sbuild::chroot::session_flags.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename schroot::Options to schroot::options.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::Session to sbuild::session.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::AuthConvTty to sbuild::auth_conv_tty.

	* Rename sbuild::AuthConv to sbuild::auth_conv.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::AuthMessage to sbuild::auth_message.

2006-02-06  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::Auth to sbuild::auth.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::Lock to sbuild::lock, sbuild::FileLock to
	sbuild::file_lock, and sbuild::DeviceLock to sbuild::device_lock.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild-config.(cc|h) to sbuild-chroot-config.(cc|h).

	* Rename sbuild::Config to sbuild::chroot_config.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::ChrootLvmSnapshot to sbuild::chroot_lvm_snapshot.

	* Rename sbuild::ChrootBlockDevice to sbuild::chroot_block_device.

	* Rename sbuild::ChrootFile to sbuild::chroot_file.

	* Rename sbuild::ChrootPlain to sbuild::chroot_plain.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* Rename sbuild::Chroot to sbuild::chroot.

	* test/config.ex2/sarge
	(run-session-scripts): Remove duplicate line.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth-conv.h: Add an error exception typedef.

	* schroot/sbuild-auth-conv-tty.cc
	(get_delay): Throw an exception on fatal timeout.  Log a warning
	rather than using std::cerr.
	(read_string): Return a string rather than a pointer to an
	allocated string.  Throw an exception on failure.
	(read_string): Don't print a newline after the prompt message.
	(conversation): Remove all string cleanup code and replace with a
	single exception handler.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-keyfile.h
	(operator >>): Linecounting counts from line 1, rather than 0.
	Fix error message capitalisation.  All parsed groups and keys are
	added to a temporary keyfile, which is then assigned to the
	current keyfile, to allow the correct catching of duplicate groups
	and keys.

	* schroot/sbuild-keyfile.cc
	(operator +=): New function.  Add all of the keys in one keyfile
	to another, overwriting keys on the lhs if already present.
	Comments are carried across.
	(operator +): New function.  Add two keyfiles together.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Add better description for the use of
	"--config".

	* schroot/schroot.conf.5.in: Document localised strings.

	* schroot/sbuild-config.cc (load): Exceptions thrown by keyfile
	parsing are not caught and treated as warnings; they are fatal.

	* schroot/sbuild-chroot.cc (set_keyfile): Get a localised value
	for the "description" key.

	* schroot/sbuild-keyfile.cc (get_locale_string): Add a set of
	overloaded functions to get localised string values.

2006-02-05  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-keyfile.cc: Update.

	* schroot/sbuild-keyfile.h
	(set_value): Overload to provide an optional comment.  Call
	set_group to create nonexistent groups on the fly.
	(set_list_value): Overload to provide an optional comment.
	(operator >>): Parse comments.

	* schroot/sbuild-keyfile.cc
	(set_group): New function to add a group with a comment.
	(get_comment): An overloaded function to get group and item
	comments.
	(print_comment): Split string to print on '\n', and correctly
	reproduce whitespace.

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* NEWS: Update.

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document new "--config" option.

	* schroot/schroot.cc (main): Print configuration if "--config" is
	specified.

	* schroot/schroot-options.cc: Add "--config" option to set
	ACTION_CONFIG.

	* schroot/schroot-options.h: New action_type enum ACTION_CONFIG.

	* schroot/sbuild-config.cc (print_chroot_config): New function to
	print chroot configuration (keyfile format).

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* Update testcases.

	* schroot/sbuild-config.cc
	(print_chroot_info): Use new chroot streaming to output details to
	an ostream.

	* print_details is protected in all derived classes.

	* schroot/sbuild-chroot.h
	(print_details): Make protected.
	(operator <<): New friend function to output chroot details to an
	ostream.

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/control (Build-Depends): Remove GLib.

	* README: Update build-dependencies.

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* Update TODO list.

	* Update testcases.

	* schroot/sbuild-config.cc (load): Use the new Chroot keyfile
	streaming functionality to initialise chroots.

	* Implement all new virtual functions in Chroot in derived
	classes.

	* Remove all functions removed from Chroot in derived classes.

	* schroot/sbuild-chroot.(cc|h)
	(Chroot): Remove overloaded construction to initialise with a
	keyfile.
	(create): Remove overloaded method for creating from a keyfile.
	(print_config): Remove.
	(get_keyfile): New protected virtual method to serialise a chroot
	to a keyfile.
	(set_keyfile): New protected virtual method to initialise a chroot
	from a keyfile.
	(operator >>): New friend function to stream from a keyfile.
	(operator <<): New friend function to stream to a keyfile.

2006-02-02  Roger Leigh  <rleigh@debian.org>

	* Simplify rethrow in catch blocks.

	* schroot/sbuild-session.cc (run_impl): Remove unneeded else
	block, to simplify the code.

2006-02-01  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update version to 0.2.2.

	* NEWS: Update version to 0.2.2.

	* configure.ac: Update version to 0.2.2.

2006-02-01  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.cc
	(Chroot): Get "mount-location" and "mount-device" from session
	keyfiles.
	(print_details): Use the correct virtual functions to get
	"Mount Location" and "Mount Device".
	(print_config): Use the correct virtual functions to get
	"mount-location" and "mount-device".

2006-02-01  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.1.

	* debian/changelog: Update for 0.2.1.

	* schroot/sbuild-session.cc (wait_for_child): Set child_status to
	EXIT_FAILURE, rather than this->child_status.  This prevents a
	non-zero exit status being returned at all times by child
	processes.

	* NEWS: Update for 0.2.1.

	* configure.ac: Update version to 0.2.1.

2006-01-30  Roger Leigh  <rleigh@debian.org>

	* Version 0.2.0.

	* schroot/schroot.conf.5.in: Add example for file chroot.

	* test/config.ex2/config: Removed (duplicated in
	test/config.ex2/sarge).

	* test/config.ex2/file: New file.  Test data for file chroots.

2006-01-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc: Beginning a session only works with
	normal chroots.  Session operations on active sessions load all
	chroots, not just session chroots.

	* schroot/sbuild-session.cc
	(run_impl): For persistent sessions, remove aliases prior to
	writing out the session data, to prevent duplicate aliases.
	(run_impl): Only run a command when performing the appropriate
	operations, rather than all the time.
	(setup_chroot): Correct bug in automatic operation which would
	potentially prevent correct cleanup.

	* schroot/sbuild-keyfile.h: Add TODO item for duplicate keys.

	* schroot/sbuild-config.cc (load): Add warnings when chroots and
	aliases names are duplicated.

2006-01-29  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-chroot-file.cc: New file.  Unit test for ChrootFile.

	* schroot/sbuild-util.cc (string_list_to_strv): New function,
	moved from sbuild-session.cc.

	* schroot/sbuild-session.cc: Remove string functions.

2006-01-29  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.cc (create): Add support for "file" type
	chroots.

	* schroot/setup/05file: Split file type checking and unpacking
	into shell functions.

	* schroot/run/00check: Add support for file chroots.

	* schroot/setup/00check: Add support for file chroots.

	* schroot/setup/Makefile.am (setup_SCRIPTS): Add 05file.

	* schroot/schroot.1.in: Update help options.

2006-01-29  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-util.cc (find_program_in_path): Return the
	program name without the absolute prefix.

	* schroot/sbuild-session.cc (run_child): Don't prefix the program
	search path (find_program_in_path), because it's already running
	inside the chroot.

	* schroot/Makefile.am (DEFS): Remove G_LOG_DOMAIN.

	* schroot/schroot-options.cc: Remove debugging messages.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* debian/rules: Don't run the testsuite.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc: Store positional arguments correctly
	using positional_options_description.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* debian/rules: Don't run the testsuite, due to it requiring root,
	or fake root, privileges.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update for 0.2.0.

	* debian/control: Suggest unzip.

	* NEWS: Update for 0.2.0.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Updated British English translation.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Remove check for stdbool.h.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.h: setup_session_info is protected and
	virtual.

	* test/Makefile.am: Distribute test data.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/05file: Filetype checks are now quiet.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* Update documentation.

	* schroot/setup/10mount: Add special cases for file chroots.

	* schroot/setup/05file: New file for unpacking and deleting
	file-based chroots.

	* schroot/sbuild-chroot-file.(cc|h): New file implementing
	file-based chroots.

	* schroot/sbuild-chroot.cc (setup_session_info): Add
	setup_session_info from ChrootLvmSnapshot.

	* schroot/sbuild-chroot-lvm-snapshot.cc: Remove setup_session_info.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-parse-value.cc: New file.  Tests for parse_value.

	* schroot/sbuild-parse-value.h (parse_value): Check failbit rather
	than badbit to catch parse errors.

	* schroot/sbuild-parse-value.cc (parse_value): Correctly parse
	false boolean values.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc (run_child): Search for the program to
	run inside the chroot, rather than on the root filesystem.

	* schroot/sbuild-util.cc (find_program_in_path): Add a prefix
	argument, to allow searching in non-root paths, for example inside
	a chroot.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-config.cc (load): Catch and handle exceptions if
	chroot creation fails.

	* schroot/sbuild-chroot.cc (create): Throw an exception if
	creation fails.

2006-01-28  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Update maintainer email address.

	* schroot/sbuild-config.h: Remove completed TODO item.

2006-01-27  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-config.cc (class test_config): Update to use active
	argument.

	* schroot/schroot.cc (main): When loading chroot configuration,
	specify if they are active sessions or not.

	* schroot/sbuild-config.cc: All methods taking a file or directory
	name also take an "active" argument to specify if the chroots
	being loaded are active sessions or not.

2006-01-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-environment.h: Remove completed TODO item about
	recommending strv_delete().

2006-01-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth-conv-tty.cc: Move static data and functions
	into the unnamed namespace.

2006-01-26  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): Only allow preservation of the user
	environment if not switching users.

	* schroot/sbuild-auth.cc (Auth, set_user): Throw exceptions rather
	than exiting on failure.
	(setupenv): Tidy up setting the environment.

2006-01-26  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.cc
	(~Auth): Shut down PAM if currently active.

2006-01-26  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-keyfile.cc
	(check_priority): Add support for PRIORITY_DISALLOWED.

	* schroot/sbuild-config.cc: Convert to throw exception instead of
	immediately terminating with an error.  This makes unit testing
	possible, and errors are all caught correctly at the top-level.

	* schroot/sbuild-chroot-lvm-snapshot.cc: When reading a keyfile,
	only allow reading "lvm-snapshot-device" when restoring an active
	chroot.

	* configure.ac (AM_INIT_AUTOMAKE): Quote argument.

	* test/sbuild-config.cc: New file.  Test for sbuild::Config.

2006-01-16  Roger Leigh  <rleigh@debian.org>

	* po/vi.po: Add Vietnamese translation.

2006-01-13  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-log.cc: New file.  Test logging with stringbufs.

	* test/sbuild-nostream.cc (test_nostream): Fix whitespace.

2006-01-13  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-nostream.cc: New file.  Test for nostream.

	* test/sbuild-environment.cc (add_simple_examples): Correct
	assertion.

2006-01-12  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-lock.cc: New file.  Tests for locking.

	* schroot/sbuild-lock.cc (set_lock): If the current process
	doesn't own the lock, unlocking always succeeds.

2006-01-12  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-keyfile.cc: New file.  Tests for keyfile.

	* schroot/sbuild-keyfile.h
	(set_value): Insert stringstream value, rather than templated
	value.
	(set_list_value): Fix bug with iterator by using binary operator +
	rather than +=.
	(operator <<): Print newline after key-value pairs.

	* schroot/sbuild-keyfile.cc
	(keyfile): Add constructor taking no arguments.
	(print_comment:	Turn into static member function.

2006-01-11  Roger Leigh  <rleigh@debian.org>

	* test/sbuild-environment.cc: New file.  Tests for environment.

	* test/testmain.cc (main): Add debugging checks.

	* test/Makefile.am (libtest_la_LIBADD): Add libsbuild.la, and
	remove from all binary LDADD lines.

	* schroot/sbuild-util.cc (strv_delete): New function moved from
	sbuild-session.cc, with the iterator type corrected.

	* schroot/sbuild-session.cc: Remove strv_delete.

	* schroot/sbuild-environment.h: Fix constness of overloaded
	operators, and correct use of lvalue in binary operators.

2006-01-11  Roger Leigh  <rleigh@debian.org>

	* Remove completed and obsolete TODO items.

	* test/sbuild-util.cc: Update testcase with fixed path.

	* schroot/sbuild-session.cc (run_child): Use new
	find_program_in_path syntax.

	* schroot/sbuild-util.cc (find_program_in_path): Add path
	argument, to allow use of paths other than $PATH.

2006-01-08  Roger Leigh  <rleigh@debian.org>

	* Update API reference.

	* test/sbuild-chroot-lvm-snapshot.cc: New file.  Tests for
	ChrootLvmSnapshot.

	* test/sbuild-chroot-block-device.cc: New file.  Tests for
	ChrootBlockDevice.

	* test/sbuild-chroot-plain.cc: New file. Tests for ChrootPlain.

	* test/test-sbuild-chroot.h: New file.  Base class for all chroot
	tests.

	* test/test-helpers.h (test_list): New file of test helper
	functions.  The initial function is a templated test for testing
	string_list getters and setters.

	* test/Makefile.am (noinst_LTLIBRARIES): Add libtest.la, a generic
	test library that contains the generic test runner and links with
	CppUnit.

	* schroot/sbuild-keyfile.h: Remove parse_value.

	* schroot/sbuild-environment.h (get): Use parse_value to parse
	values.

	* schroot/sbuild-parse-value.(cc|h): New files.  Split value
	parsing out from sbuild-keyfile to allow reuse.

2006-01-07  Roger Leigh  <rleigh@debian.org>

	* po/sv.po: Add Swedish translation.

2006-01-07  Roger Leigh  <rleigh@debian.org>

	* Add copyright and GPL boilerplate to all testcase code.

	* test/sbuild-chroot.cc: New testcase for sbuild::Chroot.

	* schroot/sbuild-environment.cc (remove): For the "char **"
	overloaded method, use the correct iterator type (the same as the
	equivalent add function).

	* schroot/sbuild-environment.h (add): Specialise templated method
	for strings.

	* schroot/sbuild-environment.h (get): New templated method to
	retrieve the value of an environment variable by its name.

2006-01-06  Roger Leigh  <rleigh@debian.org>

	* doc/Makefile.am (all-local): Don't rebuild doxygen documentation
	when not in maintainer mode.

	* configure.ac: Enable maintainer mode.

2006-01-06  Roger Leigh  <rleigh@debian.org>

	* doc/Makefile.am (EXTRA_DIST): Distribute schroot-stamp, to
	prevent documentation rebuild.

2006-01-06  Roger Leigh  <rleigh@debian.org>

	* debian/rules: Build and run the testsuite in the build target.

	* debian/control (Build-Depends): Add libcppunit-dev.

	* schroot/sbuild-util.cc
	(find_program_in_path): Split PATH on ':' characters.

	* test/sbuild-util.cc: New file: tests for sbuild-util functions.

	* test/testmain.cc: New file: test runner for all tests.

	* configure.ac: Add check and conditinal for CppUnit.

	* Makefile.am (SUBDIRS): Add test directory.

2006-01-03  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc
	(unnamed namespace): Add child_wait variable to allow debugging of
	child processes.
	(get_auth_status): Correct checks for null chroot.
	(run_impl): Correct checks for null chroot.
	(setup_chroot): Call closelog in child before exec.
	(run_child): Remove mount_location assertion, since for some
	chroot types this will fail.
	(run_child): Use command[0] rather than command[1], which may not
	exist.  Call closelog in before exec.
	(run_chroot): Loop on child_wait to allow a debugger to be
	attached to the child, if debugging is enabled.

	* schroot/sbuild-environment.cc (add): Use char ** for iterator
	type, and add additional checks for null.
	(add): Add stricter substring range checks
	(remove): Add stricter substring range checks.

	* schroot/sbuild-chroot.cc

	* schroot/sbuild-chroot-plain.cc
	(ChrootPlain): Move read_keyfile code into the constructor.

	* schroot/sbuild-chroot-lvm-snapshot.cc
	(ChrootLvmSnapshot): Move read_keyfile code into the constructor.

	* schroot/sbuild-chroot-block-device.cc
	(ChrootBlockDevice): Move read_keyfile code into the constructor.

	* schroot/sbuild-chroot.cc
	(Chroot): Move read_keyfile code into the constructor.
	(print_details): Print mount_location and mount_device if set for
	both session and non-session chroots.

2006-01-03  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.cc: Log a warning if construction fails.
	Correct buggy user assertions.

2006-01-02  Roger Leigh  <rleigh@debian.org>

	* Actually commit the new environment class.

2006-01-02  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc (Options): Rewrite the checks which
	decide which chroot configuration files should be read, depending
	upon the action specified.

	* schroot/schroot-options.h (all_used): new method to detect if
	any of the --all* options are in effect.

	* schroot/schroot.cc (main): If no chroots are available, warn
	rather than exiting with an error, since for several commands
	there may well not be any chroots defined.

	* schroot/sbuild-config.cc (validate_chroots): Correct inverse
	match which treated all correctly named chroots as being invalid.

2006-01-02  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-types.h: Remove env and env_list typedefs.

	* schroot/sbuild-session.cc: Remove env_list_to_strv helper,
	replaced by environment::get_strv().  Replace setup_env_var
	helper with environment add method.

	* schroot/sbuild-chroot.h: Chroot::setup_env() uses environment
	rather than env_list; derived classes also changed.  Removed
	setup_env_var helper.

	* schroot/sbuild-auth.h: Replace env_list with environment.
	Rename Auth::environment member to user_environment.

	* schroot/sbuild-auth.cc: Remove env_string helper.

	* schroot/sbuild-environment.(cc|h): New class sbuild::environment
	to replace sbuild::env_list and its associated helpers in a number
	of classes.  This is a collection of environment variables.

2006-01-01  Roger Leigh  <rleigh@debian.org>

	* Updated copyright notices to include 2006 changes.

	* schroot/Makefile.am: Generate a sbuild.gch precompiled header,
	and include sbuild.h in all sources which previously included an
	sbuild header.  This should improve compilation speed.

	* Rename schroot.h to sbuild.h, and include all sbuild-*.h
	headers.

	* schroot/sbuild-auth.cc (run): Fix casting to "const void **".

2005-12-31  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am (AM_CXXFLAGS): Add additional warning flags.

	* schroot/sbuild-auth.cc (run): Use a static_cast instead of a
	C-style cast.

	* schroot/sbuild-lock.cc (set_lock): Initialise the l_pid member
	of struct flock.

2005-12-31  Roger Leigh  <rleigh@debian.org>

	* Change all instances of "const T&" to "T const&" for
	consistency.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-lvm-snapshot.cc (setup_session_info):
	Imbue ostream with "C" locale.

	* schroot/sbuild-config.cc (load): Imbue istream with "C" locale.

	* schroot/sbuild-keyfile.cc (keyfile): Imbue ifstream with "C"
	locale.

	* schroot/sbuild-chroot.h (setup_env_var): Imbue stringstream with
	"C" locale.

	* schroot/sbuild-keyfile.h: All stringstreams are imbued with the
	"C" locale for locale-independent formatting.

	* schroot/schroot-releaselock.cc (main): Use C++ locale setup.

	* schroot/schroot.cc (main): Use C++ locale setup.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.cc (main): Use actions rather than old bool
	values.  Compute the session operation using the action type.
	Surround the entire function in a try/catch block, so that
	exceptions thrown during program execution are reported nicely.

	* schroot/schroot-options.cc
	(set_action): Only allow one action to be specified.
	(Options): Set the appropriate actions when parsing.  Session
	operations are represented within the action member.

	* schroot/schroot-options.h (schroot): Add action_type enum.  This
	is used to represent all actions the user may specify, rather than
	using a separate bool for each.  Remove the session operation
	member.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.h: Fix include guard naming scheme.

	* schroot/schroot-releaselock-options.(cc|h): New class for
	schroot-releaselock options parsing.  The options structure has
	been split out from schroot-releaselock.cc to create this new
	class.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* Replace all format_detail_* typedef usage with format_details.

	* schroot/sbuild-chroot.h (format_details): Templated member
	function to construct the correct format_details class template.
	This replaces all the format_detail_* typedefs.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* All code updated to use Chroot::chroot_ptr.

	* schroot/sbuild-config.cc (load): Create chroots from keyfile
	using Chroot::create.

	* schroot/sbuild-chroot.h: Chroots are created by a factory
	function returning a shared_ptr (chroot_ptr).  All chroot types
	have protected constructors, and must be created using the static
	create methods.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.h
	(format_detail::operator <<): Fix justification.

	* schroot/sbuild-chroot.cc (read_keyfile): Set chroot priority.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-config.cc (load): Insert chroot name into alias
	map in addition to alias names.

2005-12-30  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-plain.cc (read_keyfile): Use keyfile
	priorities.

	* schroot/sbuild-chroot-block-device.cc (read_keyfile): Use
	keyfile priorities.

	* schroot/sbuild-chroot.cc (read_keyfile): Set chroot name from
	group name, and use keyfile priorities.

	* schroot/sbuild-keyfile.h
	(parse_value): New templated method to parse a key value and set
	the value of the specified value type.
	(get_value): Use parse_value, and add debugging messages.  Add
	overloaded method to check key priority.
	(get_list_value): Use parse_value.  Add overloaded method to check
	key priority.
	(set_list, set_list_value): Use std::boolalpha to get text
	representation of bool.
	(operator >>): Correct off-by-one errors with substring lengths.

	* schroot/sbuild-keyfile.cc (check_priority): New method to check
	if a key is required, optional, deprecated or obsolete.  Log a
	warning or error message if a key is missing or present when it
	should not be.

	* schroot/sbuild-config.cc
	(Config): Throw error if construction fails.
	(add_config_directory): Correct error message.
	(load): Chroot type defaults to "plain".  Log a warning if the
	chroot type is incorrect.

	* schroot/sbuild-log.cc (log_debug): Report the debug level when
	printing messages.

	* schroot/schroot.cc (main): Set the default debugging level to
	DEBUG_NOTICE.

2005-12-29  Roger Leigh  <rleigh@debian.org>

	* NEWS: Bump version to 2.0

2005-12-29  Roger Leigh  <rleigh@debian.org>

	* doc/schroot.dox.in
	(PROJECT_NUMBER): Use @VERSION@.
	(WARN_LOGFILE): Log to schroot.log.

2005-12-29  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-nostream.h: Rename m_sbuf to nbuf.

2005-12-29  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Bump version to 0.2.0, following the C++ and
	doxygen work.

2005-12-28  Roger Leigh  <rleigh@debian.org>

	* Add doxygen support to configure and doc/Makefile.am, and
	distribute the doxygen-generated documentation.

2005-12-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.cc: Always qualify string_list with
	sbuild::.

2005-12-28  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth-conv-tty.h: (sbuild::AuthConvTty): Rename
	conversation_impl to conversation.

	* schroot/sbuild-auth-conv.h (sbuild::AuthConv): Remove
	conversation_impl method, replacing it with conversation.

2005-12-28  Roger Leigh  <rleigh@debian.org>

	* Document remaining undocumented functions and typedefs.
	Implementations of pure virtual functions are not documented (a
	doxygen bug, Debian bug #324117).

2005-12-28  Roger Leigh  <rleigh@debian.org>

	* Convert all inline gtk-doc documentation to Doxygen format, and
	move it from the sources into the headers.

2005-12-26  Roger Leigh  <rleigh@debian.org>

	* Convert all classes to use runtime_error_custom, and remove all
	error code enums.

	* schroot/sbuild-error.h: Remove Exception class, and replace with
	a runtime_error base class, and runtime_error_custom<> template
	class (templated on class using it), which no longer has an error
	code member (the error code was a GError holdover which was not
	used).

2005-12-26  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c:
	(run_impl, setup_chroot): Add mising format strings.

2005-12-26  Roger Leigh  <rleigh@debian.org>

	* Remove typedef'd enums in favour of plain enums.

2005-12-26  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc (is_group_member): Use new rather than
	C99 VLAs.
	(setup_chroot): setup_type_string is a std::string, rather than a
	char *.

	* schroot/sbuild-config.cc (validate_chroots): Return bad_chroots.

	* schroot/sbuild-chroot.cc (read_keyfile): Initialise bool values
	to quell compiler warning.

	* schroot/sbuild-auth.h (ErrorCode): Remove trailing comma.

	* schroot/sbuild-auth.cc
	(auth_conv): Use signed rather than unsigned int in for loops.
	(Auth::Auth): Correct member initialisation order.

	* schroot/Makefile.am (AM_CXXFLAGS): Add additional flags: -Wall
	-Wcast-align -Wwrite-strings -pedantic -Wcast-qual
	-Wredundant-decls.

2005-12-25  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Remove checks for Glib.  Glib is now completely
	removed from the sources.

	* schroot/Makefile.am (libsbuild_la_LIBADD): Remove Glib library.

	* schroot/schroot-releaselock.cc: Convert from GOption to
	Boost.Program_options.

	* schroot/schroot-options.cc: Convert from GOption to
	Boost.Program_options.

2005-12-24  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-util.cc: Remove format_string.

	* Convert all uses of sbuild::format_string to boost::format.

	* schroot/sbuild-error.h (sbuild): Add a constructor which gets
	its message from a boost::format, rather than a std::string.

2005-12-24  Roger Leigh  <rleigh@debian.org>

	* debian/control (Build-Depends): Add libboost-dev and
	libboost-program-options.

	* schroot/Makefile.am (libsbuild_la_LIBADD): Add BOOST_LIBS.

	* configure.ac: Add checks for Boost.Format and
	Boost.Program_options headers and shared libraries.

2005-12-23  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.cc:
	(sbuild_session_setup_chroot_child_setup): Remove.
	(setup_chroot): Replace g_spawn_sync with fork(), exec() and
	wait().  The uid, gid and group list are set prior to calling
	exec, as with sbuild_session_setup_chroot_child_setup previously.
	(run_child): Replace g_get_current_dir with GNU libc getcwd, and
	replace g_find_program_in_path with find_program_in_path.
	(wait_for_child): The variable to store the child exit status is
	passed in by reference, rather than being fixed.

	* schroot/sbuild-keyfile.h (keyfile::get_list_value): Use
	split_string instead of get_list_items.

	* schroot/sbuild-keyfile.cc (get_list_items): remove.

	* schroot/sbuild-util.cc
	(split_string): New function to split a string into a string_list,
	based upon sbuild::keyfile::get_list_value, but allows
	specification of a custom split character.  *
	(find_program_in_path): New function to search for an executable
	in $PATH.  A replacement for g_find_program_in_path.


2005-12-22  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.h (sbuild::Chroot::format_detail):
	template helper class to simplify streaming outout of chroot
	details.  Used by all derived chroot classes.

	* All Glib string functions have been replaced with the C++ or C99
	equivalent.

	* All uses of g_return[_val]_if_fail have been replaced with
	conditionals or static assertions.

	* All Glib logging and message functions have been replaced with
	the new logging functions and standard C++ streams.

	* All Glib types have been completely removed, with the exception
	of one instance of GError, and two uses of GOption.

	* Support for gtk-doc has been disabled and partially removed.

	* The dependency upon libsigc++ has been removed.  Virtual
	functions are used instead, which will provide more safety and
	security.

	* schroot/sbuild-keyfile.(cc|h): New class sbuild::keyfile, a
	replacement for GKeyFile.  Unlike GKeyFile, it uses templated
	methods to allow its use with any streamable type, in a type-safe
	manner.  The existing GKeyFile helper functions have been removed.

	* schroot/sbuild-log.(cc|h): New file: logging functions to
	replace the Glib print and logging utility functions.  Unlike the
	Glib types, these are based around ostreams.

	* schroot/sbuild-nostream.(cc|h): New class sbuild::basic_nostream
	with nostream and wnostream typedefs.  This is a "null ostream",
	which is a bit-bucket stream which discards all input.

	* schroot/sbuild-types.h: New file: commonly-used types.

	* Continue purge of Glib.

2005-12-19  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Replace $(GOBJECT_LIBS) with $(GLIB_LIBS).

	* configure.ac: Replace check for GObject with a check for GLib,
	and adjust $SCHROOT_CFLAGS accordingly.

	* Remove GObject support.

2005-12-19  Roger Leigh  <rleigh@debian.org>

	* Replace all use of glib/gi18n.h with sbuild-i18n.h.

	* schroot/sbuild-i18n.h: New file: gettext macros.

2005-12-19  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth-conv-tty.cc, sbuild-auth.cc: Add support for
	iostream.

	* Replace most uses of g_strdup_printf with format_string.

	* schroot/sbuild-util.cc (format_string): New function to create a
	std::string from a C-style format string.

2005-12-18  Roger Leigh  <rleigh@debian.org>

	* Remove GLib types (gboolean, gchar, gint), and replace with
	standard C++ types.

2005-12-18  Roger Leigh  <rleigh@debian.org>

	* All typedefs and enums have been moved into the class
	declarations, with the Sbuild and Object prefixes removed.

	* GError error propagation has been replaced with
	sbuild::Exception<> in all code.  The catch blocks are still
	local, simply replacing GError, but this will be fixed up later.

	* All Sbuild objects are in the "sbuild" namespace, and Schroot
	object are in the "schroot" namespace, with the prefix removed
	from the class names.

	* schroot/sbuild-error.h: Remove GError/GType glue, and replace
	with a simple templated exception class derived from
	std::runtime_error, initially to replace GError in a compatible
	manner.

2005-12-17  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-config.cc (load): Add GKeyFile error checking.

	* schroot/sbuild-chroot-lvm-snapshot.cc (read_keyfile): New
	private method to read a GKeyFile.

	* schroot/sbuild-chroot-block-device.cc (read_keyfile): New
	private method to read a GKeyFile.

	* schroot/sbuild-chroot-plain.cc (read_keyfile): New private
	method to read a GKeyFile.

	* schroot/sbuild-chroot.cc (read_keyfile): New private method to
	read a GKeyFile.

	* schroot/sbuild-keyfile.h: New file.  Simple wrapper funtions for
	interfacing with GKeyFile.

2005-12-16  Roger Leigh  <rleigh@debian.org>

	* Convert all sources from GObject-based C to ISO C++.  This
	conversion is not yet complete, but builds without error.

2005-11-07  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/schroot.init: Remove "function" bashism.

2005-11-05  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update.

	* debian/rules (config.status): Use /usr/lib rather than
	${prefix}/lib for libexecdir, to avoid unexpanded shell vars in
	config.h.

2005-11-05  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (is_group_member): Don't fail if the
	supplementary group count is 0.  Also check the process' GID in
	addition to the supplementary groups.

2005-11-05  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Update for 0.1.8.

	* NEWS: Update for 0.1.8.

	* configure.ac: Update version to 0.1.8.

2005-11-04  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.7.

	* debian/changelog: Update date.

	* NEWS: Update.

2005-11-04  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove completed items, and update new items.

	* README: Document new build dependencies.

	* schroot/schroot.conf.5.in: Add new chroot options to the examples.

	* schroot/schroot.conf: Add new chroot options to the examples.

	* schroot/schroot-setup.5.in: Document the setup and run scripts.

2005-11-03  Roger Leigh  <rleigh@debian.org>

	* debian/schroot.init: Use --quiet option to suppress an
	unnecessary error message.

	* schroot/schroot.c
	(main): If --quiet is used, don't print an error message if no
	chroots are defined.  Remove check for --quiet and --verbose, now
	moved to schroot_options_parse.

	* schroot/schroot-options.c
	(schroot_options_parse): Check if both --quiet and --verbose have
	been specified.

2005-11-02  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c
	(sbuild_session_run): Ensure child exit status is set to
	EXIT_FAILURE on session failure.
	(sbuild_session_init): Set child exit status to EXIT_SUCCESS by
	default.

	* debian/changelog: Document changes.

	* debian/rules (binary-arch): Use dh_installinit to install init
	script.

	* debian/schroot.init (NAME): New init script to perform session
	recovery at system startup.

2005-11-02  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot-options.c
	(schroot_options_parse): Don't load all chroot configurations when
	in list mode.

2005-11-02  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c
	(main): Delegate the decision about which chroot configuration
	files to load to schroot_options_parse.  Use
	sbuild_config_print_chroot_info to print chroot information.

	* schroot/schroot-options.h
	(struct _SchrootOptions): Add load_chroots and load_sessions
	members.

	* schroot/schroot-options.c
	(schroot_options_parse): Determine which chroot configuration
	files to load more accurately.

	* schroot/sbuild-config.c
	(sbuild_config_print_chroot_info): New function, split out from
	main() in schroot.c.

2005-11-01  Roger Leigh  <rleigh@debian.org>

	* Updated documentation.

	* schroot/schroot.c: Update to use the new SchrootOptions option
	parsing:
	(get_chroot_options): An SchrootOptions struct is passed as an
	argument, since the options are no longer global.
	(main): Create and free an SchrootOptions struct.

	* schroot/schroot-options.[ch]: New files.  The command-line
	option parsing has been split out of schroot.c, with an new
	SchrootOptions struct to contain the parsed options.

2005-10-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document --recover-session.

	* schroot/setup/*: Add support to setup scripts for
	"setup-recover" option.  In particular, filesystems are all
	remounted, and all "setup-start" tasks are performed, except for
	snapshotting.

	* schroot/schroot.c
	(parse_options): Add "--recover-session" session option.
	(parse_session_options): Parse "--recover-session".
	(main): Update configuration file loading to account for recovery.

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): Add support for "setup-recover"
	argument in scripts.
	(sbuild_session_run): Add support for session recovery option.

	* schroot/sbuild-session.h
	(SbuildSessionOperation): Add SBUILD_SESSION_OPERATION_RECOVER.

	* schroot/sbuild-chroot.h
	(SbuildChrootSetupType): Add SBUILD_CHROOT_SETUP_RECOVER.

2005-10-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c
	(main): Allow selection of non-session chroots as sessions, in
	order to allow session-like behaviour for all chroots, even those
	that can't natively support sessions.

	* schroot/sbuild-session.c
	(sbuild_session_run): Don't append a UUID to the session ID if the
	chroot does not support session creation.

2005-10-30  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (main): Abort if more than one chroot is
	specified when starting a session.

2005-10-28  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c
	(parse_options): Remove unused "UUID" argument description for
	running and ending sessions.
	(main): Don't set the session id.

	* schroot/sbuild-session.c
	(sbuild_session_run): If not running or ending a session, generate
	a session ID in the form "chroot_name-uuid".

2005-10-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): Propagate GError from
	sbuild_chroot_setup_lock.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_setup_lock): Use GError.  Refactor to
	propagate GError on failure, and reduce the number of return
	points.
	(sbuild_chroot_lvm_snapshot_setup_session_info): New function,
	split out from sbuild_chroot_lvm_snapshot_setup_lock to increase
	readability.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_setup_lock): Use GError.  Refactor to
	propagate GError on failure, and reduce the number of return
	points.

	* schroot/sbuild-chroot-plain.c
	(sbuild_chroot_plain_setup_lock): Use GError.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_error_quark): New function.

	* schroot/sbuild-chroot.h
	(SbuildChrootError): Add error enum.
	(SbuildChrootSetupLockFunc): Add a GError.

2005-10-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-config.c
	(sbuild_config_clear_chroot_list): New helper function to clear
	stored chroot list.
	(sbuild_config_clear): New function; uses
	sbuild_config_clear_chroot_list.
	(sbuild_config_finalize): Use sbuild_config_clear_chroot_list.

2005-10-23  Roger Leigh  <rleigh@debian.org>

	* TODO: Remove chroot default item.

	* schroot/schroot.1.in: Document default fallback.

	* schroot/schroot.c (get_chroot_options): Fall back to "default"
	chroot if no chroot was specified.

2005-10-23  Roger Leigh  <rleigh@debian.org>

	* po/en_GB.po: Updated translation.

	* TODO: Update.  All locking and session items removed now that
	they are implemented.

	* schroot/schroot.1.in: Document new "--all-chroots" and
	"--all-sessions" options.

	* schroot/schroot.c: Add "--all-chroots" and "--all-sessions"
	command-line options.
	(get_chroot_options): Use new "--all" options.
	(get_chroot_options): Print a list of invalid chroots found during
	chroot validation.
	(main): Create the configuration using sbuild_config_new(), and
	add the approprate configuration and session configuration
	depending on the command-line options used.

	* schroot/sbuild-session.c
	(sbuild_session_run): When restoring a session, set the session ID
	from the chroot name.
	(sbuild_session_run): The session operations are only run if
	specified in the session operations.

	* schroot/sbuild-config.c
	(sbuild_config_new): New function.  This does not load any
	configuration files.
	(sbuild_config_add_config_file): New function, renamed from
	sbuild_config_set_config_file.  This now exported.
	(sbuild_config_add_config_directory): New function, renamed from
	sbuild_config_set_config_directory.  This now exported.
	(sbuild_config_find_generic): Cope with the case that no chroots
	exist.
	(sbuild_config_get_chroot_list): Cope with the case that no
	chroots exist.
	(sbuild_config_validate_chroots): Return a list of invalid chroot
	names, rather than FALSE.
	(sbuild_config_class_init): "config-file" and "config-directory"
	are no longer construct-only.  Both properties are now completely
	virtual, with no corresponding member data (a single filename no
	longer makes sense when multiple configuration files may be added
	at any time).

	* schroot/sbuild-config.h (struct _SbuildConfig): Removed file
	member.

	* schroot/sbuild-chroot.h: Fix function misordering.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_print_config): Print "active" property, don't
	translate any option names, and format "mount-device" correctly.
	(sbuild_chroot_set_property): Add the PROP_ACTIVE property.
	(sbuild_chroot_class_init): Make "active" a construction property;
	this is not documented, as it is not intended for use by users; it
	is for session recovery.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_print_config): Chain up using the
	print_config vfunc.
	(sbuild_chroot_lvm_snapshot_setup_lock): Use
	sbuild_chroot_print_config rather than
	sbuild_chroot_print_details.

2005-10-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_run): Set and unset the
	chroot "active" property before and after running a session.

	* schroot/sbuild-config.c (sbuild_config_load): Remove active
	argument from sbuild_chroot_new_from_keyfile call.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_class_init): Make "active" property writable, and
	add methods to get and set the active property.
	(sbuild_chroot_new_from_keyfile): Remove active argument.

2005-10-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_run): If a chroot sets
	SBUILD_CHROOT_SESSION_CREATE, update the chroot name with the
	session name.

	* schroot/sbuild-chroot.h (SbuildChrootSessionFlags) Removed
	unused session flags, and renamed SBUILD_CHROOT_SESSION_PERSISTENT
	to SBUILD_CHROOT_SESSION_CREATE.  All chroot types updated to
	reflect the change.

2005-10-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_run): For LVM
	snapshots, set the chroot name to the session name.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_setup_lock): Write out a session file
	on session startup, and remove it when stopping the session.

2005-10-18  Roger Leigh  <rleigh@debian.org>

	* debian/rules (config.status): Add --libexecdir option to
	configure.

	* schroot/run/00check: Print new environment variables.

	* schroot/setup/05lvm: Use schroot-releaselock to release snapshot
	device lock just prior to snapshot removal.

	* schroot/setup/00check: Print new environment variables.

	* schroot/schroot-setup.5.in: Document new environment variables.

	* schroot/sbuild-session.c (sbuild_session_setup_chroot): Add
	LIBEXEC_DIR and PID setup environment variables.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_setup_lock): Don't unlock device at
	setup stop.

	* schroot/Makefile.am
	(pkglibexecdir): Set to $(SCHROOT_LIBEXEC_DIR).
	(pkglibexec_PROGRAMS): Add schroot-releaselock.

	* schroot/schroot-releaselock.c: New program to release device
	lock files using liblockdev.

	* configure.ac: Add SCHROOT_LIBEXEC_DIR define and substvar.

2005-10-17  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-lock.c (sbuild_lock_set_device_lock): Remove
	debugging print and sleep statements.

2005-10-17  Roger Leigh  <rleigh@debian.org>

	* Update documentation.

	* schroot/sbuild-chroot.c (sbuild_chroot_class_init): Remove the
	"current-users" and "max-users" properties, and associated object
	members and methods.

2005-10-17  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_setup_lock): The device lock is held
	on the source device during snapshotting (setup start), and on the
	snapshot device from run start to run stop and then during setup
	stop while the chroot is destroyed.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_setup_lock): The device lock is held
	throughout the entire session.  It is acquired at setup start and
	released at setup stop.  This uses the new sbuild-lock device
	locking primitives.

	* schroot/sbuild-chroot.h: SbuildChrootSetupLockFunc uses a
	mutable chroot object.  All implementations of the setup_lock
	vfunc have been changed accordingly.

	* schroot/sbuild-lock.c
	(sbuild_lock_set_device_lock): New function.  Lock a device using
	liblockdev.
	(sbuild_lock_unset_device_lock): New function.  Unlock a device
	using liblockdev.

2005-10-14  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.1.7.

	* debian/control (Build-Depends): Add liblockdev1-dev.

	* schroot/Makefile.am (schroot_LDADD): Add $(LOCKDEV_LIBS).

	* configure.ac: Check for liblockdev.

	* Bump version to 0.1.7.

2005-10-14  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Restore session options.

	* schroot/schroot.c (parse_options): Restore session options.

2005-10-13  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.6.

	* debian/changelog: Update

	* TODO: Update.

	* NEWS: Update.

	* schroot/schroot.1.in: Remove unused session options.

	* schroot/schroot.c: Disable unused session options.

2005-10-12  Roger Leigh  <rleigh@debian.org>

	* All manpages updated to document the new names and directory
	locations.

	* schroot/sbuild-chroot.h: Rename SBUILD_CHROOT_SETUP_START and
	SBUILD_CHROOT_SETUP_STOP to SBUILD_CHROOT_RUN_START and
	SBUILD_CHROOT_RUN_STOP.  Users of the enum changed to use the new
	names.

	* session.d script "session-start" and "session-stop" script
	arguments renamed to "run-start" and "run-stop".  All scripts
	changed to use the new names, and sbuild-session.c runs the
	scripts with the new new names.

	* Rename schroot/session to schroot/run.  Install scripts into
	$sysconfdir/schroot/run.d.  Update configure.ac, and
	schroot/Makefile.am.

2005-10-12  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_setup_chroot): Use new
	function names.

	* schroot/sbuild-chroot-lvm-snapshot.c: Use new vfunc names.
	(sbuild_chroot_lvm_snapshot_setup_lock): stat devices, but still
	needs liblockdev support for full locking.

	* schroot/sbuild-chroot-block-device.c: Use new vfunc names.
	(sbuild_chroot_block_device_setup_lock): stat devices, but still
	needs liblockdev support for full locking.

	* schroot/sbuild-chroot-plain.c: Use new vfunc names.
	(sbuild_chroot_plain_setup_lock): Do no locking by default.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_setup_lock): Renamed from
	setup_chroot_get_setup_name.
	(sbuild_chroot_setup_env): Renamed from sbuild_chroot_setup.
	(sbuild_chroot_class_init): Use new vfunc names.

	* schroot/sbuild-chroot.h (struct _SbuildChrootClass): Rename
	setup to setup_env and get_setup_name to setup_lock, which now
	returns gboolean on lock failure.

2005-10-05  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Manual pages say "schroot" rather than
	"sbuild".  Closes Debian Bug #331550.

	* schroot/schroot.conf.5.in: Use "schroot" rather than "sbuild".

2005-10-01  Roger Leigh  <rleigh@debian.org>

	* configure.ac: Output schroot-setup.5

	* schroot/Makefile.am (man_MANS): Add schroot-setup.5

	* schroot/schroot.1.in: Remove setup script documentation.

	* schroot/schroot-setup.5.in: New file, documenting setup script
	environment.

2005-10-01  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/Makefile.am: Distribute 05lvm.

	* schroot/setup/10mount: Use new LVM variables, so snapshot names
	and mount locations are as set by the session.  Remove mount
	directory after unmounting, but only if it's under $MOUNT_DIR.

	* schroot/setup/05lvm: Use new LVM variables, so snapshot names
	and mount locations are as set by the session.

	* schroot/setup/00check, schroot/session/00check: Add MOUNT_DIR,
	SESSION_ID, CHROOT_LVM_SNAPSHOT_NAME and
	CHROOT_LVM_SNAPSHOT_DEVICE.

	* schroot/schroot.c
	(parse_options): Free the option context after use.
	(main): If a session ID was not specified, generate a UUID for the
	session.
	(main): Free the chroot list to make valgrind happy.

	* schroot/schroot.1.in: Document MOUNT_DIR, SESSION_ID,
	CHROOT_LVM_SNAPSHOT_NAME and CHROOT_LVM_SNAPSHOT_DEVICE
	environment variables.

	* schroot/sbuild-session.c
	(sbuild_session_get_session_id): session-id is no longer required
	to be a UUID.
	(sbuild_session_set_session_id): session-id is no longer required
	to be a UUID.  Allow setting of arbitrary strings.
	(sbuild_session_setup_chroot): Export MOUNT_DIR and SESSION_ID in
	the environment.
	(sbuild_session_run): Set the chroot mount location if the chroot
	did not already do so.
	(sbuild_session_run): For LVM snapshot chroots, set the snapshot
	name to the session ID.
	(sbuild_session_run): Cascade error handling properly on failure.
	(sbuild_session_class_init): Update session-id documentation now
	it is no longer a strict UUID.

	* schroot/sbuild-session.h (struct _SbuildSession): Change
	session_id type from uuid_t to gchar *.

	* schroot/sbuild-config.c (sbuild_config_load): Free GIOChannel,
	file data buffer and GKeyFile structure after use.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_print_config): Don't print NULL
	values.
	(sbuild_chroot_lvm_snapshot_setup): Don't set NULL values.  Set
	snapshot device name (path stripped) as CHROOT_LVM_SNAPSHOT_NAME.
	(sbuild_chroot_lvm_snapshot_get_setup_name): Implement
	get_setup_name vfunc.  This is of the form block-major-minor,
	obtained by stat()ing the block device.  For setup-start, this is
	the source LV, but for all other cases is the snapshot LV.
	(sbuild_chroot_lvm_snapshot_class_init): Added new
	"snapshot-device" property.  The "device" property is slaved to
	this value, and indirectly, the "device" property is also slaved.

	* schroot/sbuild-chroot-lvm-snapshot.h (struct
	_SbuildChrootLvmSnapshot): New snapshot_device member.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_print_details): Don't print NULL
	values.
	(sbuild_chroot_block_device_print_config): Don't print NULL
	values.
	(sbuild_chroot_block_device_setup): Don't set NULL values.
	(sbuild_chroot_block_device_get_setup_name): Implement
	get_setup_name vfunc.  This is of the form block-major-minor,
	obtained by stat()ing the block device.

	* schroot/sbuild-chroot-plain.c
	(sbuild_chroot_plain_print_details): Don't print NULL values.
	(sbuild_chroot_plain_print_config): Don't print NULL values.
	(sbuild_chroot_plain_setup): Don't set NULL values.
	(sbuild_chroot_plain_get_setup_name): Implement get_setup_name
	vfunc.  This is of the form directory-major-minor-inode, obtained
	by stat()ing the mount location.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_set_properties_from_keyfile): Don't leak GKeyFile
	string and string vector values.
	(sbuild_chroot_get_setup_name): New function.  Get the name for
	e.g. locking during setup.
	(sbuild_chroot_print_details): Don't print NULL values.
	(sbuild_chroot_print_config): Don't print NULL values.
	(setup_env_string): New helper function to build environment list.
	(setup_env_unsigned): New helper function to build environment list.

	* schroot/sbuild-chroot.h (struct _SbuildChrootClass): Add
	get_setup_name vfunc.

	* schroot/sbuild-auth.c (sbuild_auth_setupenv): Don't leak new
	environment.

	* schroot/Makefile.am (install-data-hook): Create mount directory.

	* configure.ac (SCHROOT_MOUNT_DIR): Add mount directory.

2005-09-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-lock.c: Minor documentation and error message
	tidying.

2005-09-27  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-config.c (sbuild_config_load): Report GError
	messages propagated by locking failure.

	* schroot/sbuild-lock.c
	(sbuild_lock_set_lock): Return errors as a GError, rather than
	aborting.  Don't run fcntl in a while loop now that timeouts are
	implemented with an itimer.
	(sbuild_lock_unset_lock): Return errors as a GError.
	(sbuild_lock_error_quark): New function.

	* schroot/sbuild-lock.h (SBUILD_LOCK_ERROR): Add error domain.
	Add locking errors as SbuildLockError enum.

2005-09-27  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Update documentation.

	* schroot/sbuild-chroot.c (sbuild_chroot_class_init): The
	run-session-scripts property defaults to FALSE, for compatibility
	with dchroot out-of-the-box.

2005-09-27  Roger Leigh  <rleigh@debian.org>

	* Update documentation.

	* schroot/sbuild-config.c (sbuild_config_load): Acquire a read
	lock while reading schroot.conf.

	* schroot/schroot.h: Add sbuild-lock.h.

	* schroot/Makefile.am: Add sbuild-lock.[ch].

	* schroot/sbuild-lock.[ch]: New file, implementing simple
	whole-file advisory locking primitives.

2005-09-25  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/00check: Remove "session-start" check.

	* schroot/session/00check: Remove duplicate "session-start" check.

	* schroot/session/50sbuild: New script to set up sbuild build
	directory and fix its ownership and permissions.

2005-09-25  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document new session.d directory.

	* schroot/schroot.conf.5.in: Document run-setup-scripts and
	run-session-scripts options.

	* schroot/sbuild-chroot.c (sbuild_chroot_class_init): Replace
	run-setup property and associated accessors with two new
	properties, run-setup-scripts and run-session-scripts and
	associated accessors.  Setup script are not run by default,
	whereas session scripts are.

	* schroot/sbuild-chroot.h (struct _SbuildChroot): Replace
	run_setup with two members, run_setup_scripts and
	run_session_scripts.

	* schroot/Makefile.am (SUBDIRS): Add session.

	* schroot/session/00check: New session script.

	* schroot/session/Makefile.am: New file for installing session
	scripts.

	* configure.ac (SCHROOT_CONF_SETUP_D): New define and substitution
	variable.

2005-09-25  Roger Leigh  <rleigh@debian.org>

	* Update API reference.

	* schroot/schroot.1.in: Document new command-line options.

	* schroot/schroot.c: Add new session_opt struct, with operation,
	id and force members.
	(parse_options): Add new command line options: -b/--begin-session,
	-r/--run-session, -e/--end-session and --force in a new "session"
	option group.  These options do not currently have any effect.
	(parse_session_options): New helper function to parse session
	options.
	(main): Set session operation when creating a new session.  Set
	additional session properties (session-id, force) after
	construction.

	* schroot/sbuild-session.c (sbuild_session_class_init): Added new
	"operation" and "force" properties, and associated accessors.
	(sbuild_session_new): Add operation argument, and set the
	operation contruction property.

	* schroot/sbuild-session.h: Added SbuildSessionOperation enum to
	specify session operations.
	(struct _SbuildSession): Added new operation and force members.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_get_session_flags): New virtual
	function to get session flags.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_get_session_flags): New virtual
	function to get session flags.

	* schroot/sbuild-chroot-plain.c
	(sbuild_chroot_plain_get_session_flags): New virtual function to
	get session flags.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_get_session_flags): New function.  Calls
	get_session_flags vfunc.
	(sbuild_chroot_class_init): get_session_flags is pure virtual, so
	must be implemented in derived classes.

	* schroot/sbuild-chroot.h: Add SbuildChrootSessionFlags enum to
	specify chroot session behaviour.
	(struct _SbuildChrootClass): Added get_session_flags vfunc.

2005-09-24  Roger Leigh  <rleigh@debian.org>

	* debian/rules (config.status): Set $localstatedir when running configure.

2005-09-24  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Document new setup script parameters.

	* Modify all setup scripts to use the new setup names.

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): Use SbuildChrootSetupTyoe to run
	the four different types of setup operation.
	(sbuild_session_run): Run the four different kinds of setup script
	in the correct order.

	* schroot/sbuild-chroot.h: Add SbuildChrootSetupType enum to
	replace internal SbuildSessionChrootSetupType.  This has
	enumerations for starting and stopping both chroot setup and
	session setup.

2005-09-24  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.c
	(sbuild_chroot_set_properties_from_keyfile): Split keyfile
	property code out from sbuild_chroot_new_from_keyfile.  This will
	allow re-reading chroot configuration from disk for session
	handling.

2005-09-24  Roger Leigh  <rleigh@debian.org>

	* debian/preinst, debian/postinst: Preserve schroot.conf changes
	correctly when moving to /etc/schroot/schroot.conf, by checking
	the md5sum to detect local modifictions.  If not modified, delete
	and replace with the package version.

2005-09-22  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_run): Move chroot mount
	location fallback from sbuild_session_setup_chroot.

	* schroot/schroot.conf.5.in: Add additional "run-setup" notes.

2005-09-21  Roger Leigh  <rleigh@debian.org>

	* debian/changelog: Bump version to 0.1.6.  Document run-setup
	changes for Debian Bug #329403.

	* schroot/schroot.conf.5.in: Document "run-setup" configuration
	option.

	* schroot/sbuild-session.c (sbuild_session_run): Only run setup
	scripts if enabled in the chroot configuration.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_class_init): Add "run-setup" property, and
	associated accessors.
	(sbuild_chroot_new_from_keyfile): Add support for G_TYPE_BOOLEAN
	properties as configuration options.

	* schroot/sbuild-chroot.h (struct _SbuildChroot): Add run_setup
	member.

2005-09-20  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.c
	(sbuild_chroot_new_from_keyfile): Fix a memory leak during chroot
	type identification.  Reorganise code to make layout more logical.
	(sbuild_chroot_print_details): Format detail listing to make it
	more readable, in the same style as used by the LVM tools.

	* schroot/sbuild-config.c (sbuild_config_load): Only add chroots
	to the SbuildConfig if they were successfully constructed.

2005-09-18  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_class_init): Add a new
	session-id property and associated accessors, which handle
	conversions between a string and uuid_t.

	* schroot/sbuild-session.h (struct _SbuildSession): Add a new
	session_id member containing the session UUID.

	* schroot/sbuild-config.c
	(sbuild_config_new_from_file): New function to replace
	sbuild_config_new.
	(sbuild_config_new_from_directory): New function to load a set of
	configuration files from a directory.
	(sbuild_config_class_init): config-file property is no longer
	readable.  Added new contruct only and write-only config-directory
	property.
	(sbuild_config_set_config_directory): New function to read a
	directory and load config files.
	(sbuild_config_load): Pass back the chroot list as an OUT
	parameter rather than a return value, to allow reusing the same
	list.
	(sbuild_config_set_config_file): Remove the restriction on loading
	a single config file.

	* schroot/sbuild-chroot-lvm-snapshot.c
	(sbuild_chroot_lvm_snapshot_print_config): New virtual function to
	print additional configuration details.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_print_config): New virtual function to
	print additional configuration details.

	* schroot/sbuild-chroot-plain.c
	(sbuild_chroot_plain_print_config): New virtual function to print
	additional configuration details.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_class_init): Added current-users, max-users and
	active properties, and associated accessors.
	(sbuild_chroot_new_from_keyfile): Add additional active parameter
	which is TRUE if reloading an existing session configuration.
	This relaxes permissions checks to allow setting of writable but
	not construction parameters.
	(sbuild_chroot_print_details): Print new properties.
	(sbuild_chroot_print_config): New function to write out current
	session state to a a configuration file for later restoration.
	(sbuild_chroot_setup): Set new properties as environment
	variables, except for active, since this is implicit in running a
	session).

	* schroot/sbuild-chroot.h
	(struct _SbuildChroot): Add current_users, max_users and active
	members.
	(struct _SbuildChrootClass): Add print_config vfunc.

	* debian/control (Build-Depends): Build-depend upon uuid-dev

	* schroot/Makefile.am
	(schroot_LDADD): Link with libuuid.
	(install-data-hook): Make SCHROOT_LOCK_DIR and
	SCHROOT_SESSION_DIR.

	* configure.ac:
	Check for libuuid and add UUID_CFLAGS to SCHROOT_CFLAGS.
	Add substitutions and defines for SCHROOT_LOCK_DIR and
	SCHROOT_SESSION_DIR.

2005-09-16  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-chroot.c (sbuild_chroot_new_from_keyfile):
	Require settable properties to be both constructible and writable.

2005-09-15  Roger Leigh  <rleigh@debian.org>

	* TODO: Update.

	* schroot/schroot.1.in: Document LVM snapshot script variables.

	* schroot/schroot.conf.5.in: Document LVM snapshot options.

	* schroot/setup/10mount: Hack LVM snapshot device name until it's
	supported by the session code.

	* schroot/setup/05lvm: New script to create and remove LVM
	snapshots.  Hack LVM snapshot device name until it's supported by
	the session code.

	* schroot/setup/00check: Report $CHROOT_LVM_SNAPSHOT_OPTIONS.

	* schroot/sbuild-chroot.c (sbuild_chroot_new_from_keyfile): Allow
	creation from type "lvm-snapshot".

	* schroot/sbuild-chroot-lvm-snapshot.[ch]: New files, implementing
	SbuildChrootLvmSnapshot, an object representing a chroot on a LVM
	logical volume which has a snapshot LV taken on demand, derived
	from SbuildChrootBlockDevice.

2005-09-15  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/Makefile.am (setup_SCRIPTS): Distribute 00check
	and 10mount.

2005-09-15  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/10mount: Use $CHROOT_MOUNT_DEVICE.

	* schroot/setup/00check: Report $CHROOT_MOUNT_DEVICE.

	* schroot/sbuild-chroot-plain.c: Minor indentation fixes.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_set_mount_device): New function to
	slave the "device" property to the parent class "mount-device"
	property.
	Minor indentation fixes.

	* schroot/sbuild-chroot.c (sbuild_chroot_class_init): Added
	"mount-location" property and associated accessors.

	* schroot/sbuild-chroot.h (struct _SbuildChroot): Added
	mount_location member.

2005-09-15  Roger Leigh  <rleigh@debian.org>

	* schroot/setup/50chrootname: Use ${CHROOT_MOUNT_LOCATION}.

2005-09-14  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.conf.5.in: Document "mount-options".

	* schroot/setup/00check: Report $CHROOT_MOUNT_OPTIONS.

	* schroot/sbuild-chroot-block-device.c
	(sbuild_chroot_block_device_class_init): Added a "mount-options"
	property and associated accessors.

	* schroot/sbuild-chroot-block-device.h (struct
	_SbuildChrootBlockDevice): Added a mount_options member.

2005-09-14  Roger Leigh  <rleigh@debian.org>

	* Updated documentation.

	* schroot/setup/30passwd: Use $CHROOT_MOUNT_LOCATION.

	* schroot/setup/20network: Use $CHROOT_MOUNT_LOCATION.

	* schroot/setup/10mount: New script to mount block devices.

	* schroot/setup/00check: New script to do sanity checking before
	other scripts are run, and print the environment when run in
	verbose mode.

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): Fall back to "/mnt" if no mount
	location is available.  This is temporary.
	(sbuild_session_setup_chroot): Set the environment correctly for
	subclassed SbuildChroot objects.
	(sbuild_session_setup_chroot_child_setup): New helper function to
	ensure that the setup scripts run as real and effective user and
	group root.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_get_chroot_type): New function, which calls the
	get_type vfunc.
	(sbuild_chroot_class_init): Renamed "location" property to
	"mount-location", and updated all methods accordingly.  "location"
	is now implemented only in SbuildChrootPlain.
	(sbuild_chroot_new_from_keyfile): Check the GKeyFile "type" key to
	check which SbuildChroot subclass to instantiate.  Add stricter
	checking of GKeyFile keys, by validating names and types against
	the registered properties for the GObjectClass, as well as
	checking if the properties are constructible and writable.

	* schroot/sbuild-chroot.h (struct _SbuildChrootClass): Added new
	get_type vfunc, for getting the type name of the chroot.

	* schroot/sbuild-chroot-block-device.[ch]: New files, implementing
	SbuildChrootBlockDevice, an object representing a chroot on a
	block device mounted on demand, derived from SbuildChroot.

	* schroot/sbuild-chroot-plain.[ch]: New files, implementing
	SbuildChrootPlain, an object representing a simple filesystem
	chroot, derived from SbuildChroot.

	* NEWS: Bump version to 0.1.6.

	* configure.ac: Bump version to 0.1.6.

	* schroot/sbuild-chroot.c (sbuild_chroot_new_from_keyfile): Warn
	if not constructible or writable types are used.

2005-09-13  Roger Leigh  <rleigh@debian.org>

	* Translate g_warning messages.

	* schroot/schroot.c (main): When printing detailed chroot
	information, add a blank line between chroots.

	* schroot/sbuild-chroot.c (sbuild_chroot_new_from_keyfile): Parse
	options automatically by introspecting the GObject properties for
	a given chroot GType.  This will allow for automatic extension of
	the file format as new chroot types are added.

2005-09-12  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_setup_chroot): Call
	sbuild_chroot_setup to get chroot environment variables, and add
	additional auth environment variables to the same linked list.
	Convert the linked list into a vector.

	* schroot/sbuild-chroot.c (sbuild_chroot_print_details): Call
	print_details vfunc.
	(sbuild_chroot_setup): New function, used to set the environment
	in setup scripts.  It calls the setup vfunc to allow derived
	classes to set additional environment variables.

	* schroot/sbuild-chroot.h:
	(struct _SbuildChrootClass): New print_details and setup virtual
	functions.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* Fixed minor typos in API reference.

	* Updated TODO.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_setup_chroot): Set
	AUTH_VERBOSITY, not AUTH_VERBOSE.

	* schroot/setup/50chrootname: Use $AUTH_VERBOSITY.

	* schroot/setup/30passwd: Use $AUTH_VERBOSITY.

	* schroot/setup/20network: Use $AUTH_VERBOSITY.

	* schroot/schroot.c (main): Fix pointer type warning.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* Update API reference.

	* schroot/schroot.1.in: Document new option, and the
	AUTH_VERBOSITY environment variable used in setup scripts.

	* schroot/schroot.c
	(parse_options): Add a new --verbose option.
	(main): Set requested verbosity level.

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): Check verbosity level to set in the
	environment, and to pass to run-parts.
	(sbuild_session_run_child): Check verbosity level when printing
	information about the command being run.

	* schroot/sbuild-auth.c
	(sbuild_auth_get_verbosity): Replacement for
	sbuild_auth_get_quiet.
	(sbuild_auth_set_verbosity): Replacement for
	sbuild_auth_set_quiet.
	(sbuild_auth_class_init): Replace "quiet" property with
	"verbosity" property.

	* schroot/sbuild-auth.h:
	Add SbuildAuthVerbosity enum to specify	message verbosity.
	(struct _SbuildAuth): Replace quiet member with verbosity member.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.5.

	* po/en_GB.po: Update.

	* debian/changelog: Update.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* debian/rules: Install the lintian override.

	* debian/schroot.lintian-overrides: New file to override
	setuid-binary lintian warning.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am (EXTRA_DIST): Correctly distribute
	schroot.conf.

	* debian/copyright (License): Update the FSF address.

2005-09-11  Roger Leigh  <rleigh@debian.org>

	* configure.ac:
	Check for run-parts.
	Define $PACKAGE_SYSCONF_DIR as the location for configuration files.
	Define $SCHROOT_CONF_SETUP_D as the location for setup scripts.

	* schroot/Makefile.am (pkgsysconfdir): Install schroot.conf into
	$(PACKAGE_SYSCONF_DIR).

	* schroot/schroot.conf.5.in: Update date.

	* schroot/schroot.1.in: Add setup.d to FILES.  Update date.

	* schroot/setup/Makefile.am: Distribute and install 20network,
	30passwd and 50chrootname into $sysconfdir/schroot/setup.d.

	* schroot/setup/50chrootname: New file to set up chroot name in
	/etc/debian_chroot.

	* schroot/setup/30passwd: New file to set up passwd, shadow and
	group.

	* schroot/setup/20network: New file to set up resolv.conf.

	* schroot/sbuild-session.h: Add SBUILD_SESSION_ERROR_CHROOT_SETUP
	GError enum.

	* schroot/sbuild-session.c
	(sbuild_session_setup_chroot): New function to call run-parts(8).
	(sbuild_session_run): Call sbuild_session_setup_chroot before and
	after running the session command or shell.

2005-08-25  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (main): Replace SCHROOT_CONFIG_FILE with
	SCHROOT_CONF.

	* schroot/Makefile.am (DEFS): Remove SCHROOT_CONFIG_FILE.

	* schroot/schroot.conf.5.in: Use @SCHROOT_CONF@, rather than the
	incorrect @prefix@/etc/schroot.conf.

	* schroot/schroot.1.in: Use @SCHROOT_CONF@, rather than the
	incorrect @prefix@/etc/schroot.conf.

	* configure.ac (PACKAGE_SYSCONF_DIR): Compute the final value of
	$sysconfdir before configure ends, and substitute and define
	SCHROOT_CONF with the location of schroot.conf.

2005-08-22  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.c (sbuild_auth_require_auth_impl): Remove
	special root priveleges.

	* schroot/sbuild-session.c (sbuild_session_require_auth): Remove
	special root priveleges.

2005-08-21  Roger Leigh  <rleigh@debian.org>

	* schroot/Makefile.am: Added new source files.

	* schroot/schroot.c (main): Add support for SbuildAuthConv
	timeouts.

	* schroot/schroot.h: Added new headers.

	* schroot/sbuild-marshallers.list: Added new marshaller
	BOOLEAN:UINT,BOXED.

	* configure.ac: Remove check for libpam_misc.  Bump version to
	0.1.5

	* schroot/sbuild-auth.c: Add support for the conv member as a
	GObject property:
	(sbuild_auth_get_conv): New function.
	(sbuild_auth_set_conv): New function.
	(sbuild_auth_conv): New function; glue to interface PAM to
	SbuildAuthConv.
	(sbuild_auth_start): Create a custom pam_conv which uses
	sbuild_auth_conv to hook back into SbuildAuthConv from PAM.

	* schroot/sbuild-auth.h: Add conv member to _SbuildAuthConv and
	sbuild_auth_get_conv and sbuild_auth_set_conv getters and setters,
	used to get and set the SbuildAuthConv interface used.

	* schroot/sbuild-auth-conv-tty.[ch]: New files, adding the
	SbuildAuthConvTty implementation of SbuildAuthConv.

	* schroot/sbuild-auth-conv.[ch]: New files, adding the
	SbuildAuthConv GInterface.

	* schroot/sbuild-auth-message.[ch] New files, adding the
	SbuildAuthMessagea and SbuildAuthMessageVector structures
	(registered as GBoxed types).

2005-07-31  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.4.

	* NEWS: Update for 0.1.4.

	* po/en_GB.po: Update translation.

2005-07-31  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c (sbuild_session_run_child): Alter the
	message printed to stderr or logged with syslog, depending on
	whether the environment is being preserved (no login shell) or not
	(login shell).

2005-07-31  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (main): Set the service name to "schroot".

	* schroot/sbuild-session.c (sbuild_session_new): Set the
	SbuildAuth "service" construction property.

	* schroot/sbuild-auth.h (struct _SbuildAuth): Add service member.

	* schroot/sbuild-auth.c: Don't hardcode the PAM service name:
	(sbuild_auth_get_service): New function.
	(sbuild_auth_set_service): New function.
	(sbuild_auth_start): Use the service member when initialising PAM.

2005-07-31  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.1.in: Include priority in the examples.

	* schroot/schroot.conf.5.in: Document new priority option and
	include it in the examples.

	* schroot/sbuild-chroot.h (struct _SbuildChroot): Add priority
	member.

	* schroot/sbuild-chroot.c
	(sbuild_chroot_get_priority): New function
	(sbuild_chroot_set_priority): New function
	(sbuild_chroot_new_from_keyfile): Parse priority

2005-07-31  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (parse_options): Fix typo in documentation.

	* schroot/sbuild-session.c (sbuild_session_require_auth): Simplify
	by removing all redundant checks.

2005-07-17  Roger Leigh  <rleigh@debian.org>

	* debian/control (Build-Depends): Add gettext.

	* Bump version numbers to 0.1.4.

2005-07-17  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.3.

	* NEWS: Update for 0.1.3.

2005-07-17  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.c (sbuild_auth_setupenv): Add USER and
	LOGNAME to the list of environment variables to set if not
	preserving the old environment.

2005-07-17  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-auth.c
	(sbuild_auth_get_home): Add home directory property and get
	function for the session user.
	(sbuild_auth_setupenv): Add HOME to the list of environment
	variables to set if not preserving the old environment.

2005-07-16  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.c
	(sbuild_session_run_chroot): Split into two separate functions,
	sbuild_session_run_child() and sbuild_session_wait_for_child().
	(sbuild_session_wait_for_child): Notify the "child-status"
	property on change.

2005-07-11  Roger Leigh  <rleigh@debian.org>

	* TODO: Update.

	* Update gtk-doc documentation.

2005-07-10  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (main): Abort earlier if no chroots are
	defined in schroot.conf.

2005-07-09  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c (parse_options): Move the option entries[]
	array into the function as a static const variable.  Make sure the
	array is terminated by a null option entry, to prevent a segfault
	when parsing the options.

2005-07-08  Roger Leigh  <rleigh@debian.org>

	* TODO: Update.

	* schroot/schroot.c (main): Use new SBUILD_AUTH casts and methods,
	to replace the corresponding SBUILD_SESSION types and methods.

	* SbuildSession derives from SbuildAuth.
	  - The duplicated functionality has been removed from
	    SbuildSession.
	  - SbuildSession overrides the SbuildAuth virtual functions
	    require_auth and session_run.

2005-07-08  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.h: Add sbuild-auth.[ch].

	* schroot/sbuild-marshallers.list: Add new marshaller
	(sbuild_cclosure_marshal_BOOLEAN__BOXED).

	* Split SbuildSession PAM functionality into a separate SbuildAuth
	class, from which SbuildSession is derived.  SbuildAuth handles
	authentication and authorisation using PAM, with hooks for
	customising its behaviour.

2005-07-07  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-session.h, schroot/sbuild-config.h: Make error
	quark functions publicly visible.

2005-07-07  Roger Leigh  <rleigh@debian.org>

	* schroot/schroot.c
	(entries): Make entries const, to fix compiliation with gcc-4.0.
	(parse_options): Check for parse errors, and exit on error.

2005-07-07  Roger Leigh  <rleigh@debian.org>

	* schroot/sbuild-error.c, schroot/sbuild-error.h: Wrap GError as a
	GType (SBUILD_TYPE_ERROR and SBUILD_TYPE_ERROR_POINTER) for use
	with signals (GError * may be used as an "out" argument).

2005-07-05  Roger Leigh  <rleigh@debian.org>

	* po/.cvsignore: Ignore generated files.

2005-07-04  Roger Leigh  <rleigh@debian.org>

	* doc/schroot/schroot-docs.sgml: Include marshallers section.

	* doc/schroot/schroot-sections.txt: Add marshallers section.

	* schroot/schroot.h: New header.  This includes all other headers,
	and is used by glib-mkenums.

	* schroot/sbuild-marshallers.list: New file.  Generate a
	marshaller returning an enum and taking no arguments
	(sbuild_cclosure_marshal_ENUM__VOID).

	* schroot/Makefile.am: Generate GObject closure marshallers and
	GType typebuiltins.  Distribute the generated code.

2005-07-03  Roger Leigh  <rleigh@debian.org>

	* configure.ac, NEWS, debian/changelog: Increase version number to
	0.1.3.

2005-07-02  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.2.

	* schroot/sbuild-session.c
	(sbuild_session_pam_setupenv): If no environment was specified,
	create an initial environment containing PATH and TERM.
	(sbuild_session_run_chroot): Search PATH for the specified
	command, in case the user didn't use an absolute path.

	* schroot/schroot.1.in: Add additional usage examples.

2005-07-02  Roger Leigh  <rleigh@debian.org>

	* README: Remove usage examples.

	* schroot/schroot.conf.5.in: Don't indent example.

	* schroot/schroot.1.in: Add usage examples.

2005-07-02  Roger Leigh  <rleigh@debian.org>

	* Updated README (translation and usage examples).

	* po/en_GB.po: Add British English translation.

	* po/en.po: Remove.

2005-06-25  Roger Leigh  <rleigh@debian.org>

	* debian/control (Standards-Version): Upgrade to Standards-Version
	3.6.2.

2005-06-25  Roger Leigh  <rleigh@debian.org>

	* configure.ac, NEWS, debian/changelog: Increase version number to
	0.1.2.

2005-06-25  Roger Leigh  <rleigh@debian.org>

	* Remove UCS characters from string literals.  For the time being,
	gettext will have to handle this.

	* Update .cvsignore files.

	* TODO: Remove gettext item.

	* po/en.po: Add an English translation, to make use of UTF-8
	characters.

	* schroot/Makefile.am, schroot/*.c: Mark up strings for
	translation with gettext, and add gettext and locale
	initialisation code to main().

	* Add po/POTFILES.in with all C source files included.

	* Add additional options to po/Makevars, to make xgettext read
	the source as UTF-8.

	* bootstrap, configure.ac, Makefile.am: add GNU gettext support.

2005-06-21  Roger Leigh  <rleigh@debian.org>

	* Version 0.1.1.

	* schroot/sbuild-config.c (sbuild_config_validate_chroots):
	  use g_return_val_if_fail, not g_return_if_fail.

	* configure.ac: Remove the automake "tar-pax" option, because the
	  Debian build infrastructure can't cope with it yet.

2005-06-21  Roger Leigh  <rleigh@debian.org>

	* Change all GPL boilerplate to use the new FSF postal address.

2005-06-21  Roger Leigh  <rleigh@debian.org>

	* debian/copyright:
	  - Update the postal address of the FSF.
	  - Refer to /usr/share/common-licenses/GPL.
	  - Add new download location.

	* Makefile.am: Remove CVS directories from the generated tarball.

	* schroot/schroot.conf.5.in: Correct .TH section from 1 to 5.

	* Remove debian/conffiles, which is not required by debhelper.

	* debian/control: Add buildd-tools developers to
	  Uploaders, and remove unused ${misc:Depends}.

	* debian/changelog: Update.

2005-06-21  Roger Leigh  <rleigh@debian.org>

	* Add .cvsignore files to replace lost .arch-inventory files.

2005-06-21  Roger Leigh  <rleigh@debian.org>

	* Add ChangeLog to CVS
	* No longer generate ChangeLog with "tla changelog".  It must now
	  be edited manually.

2005-06-20 23:06:04 GMT	Roger Leigh <rleigh@debian.org>	patch-1

    Summary:
      Add strict pointer checks and bump version
    Revision:
      schroot--mainline--0.1.1--patch-1

    - Add strict pointer checks to all function arguments and before
      dereferencing object members.
    - Increase version number to 0.1.1.

    modified files:
     NEWS configure.ac debian/changelog schroot/sbuild-chroot.c
     schroot/sbuild-config.c schroot/sbuild-session.c
     schroot/schroot.c


2005-06-20 15:45:19 GMT	Roger Leigh <rleigh@debian.org>	base-0

    Summary:
      tag of rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--version-0
    Revision:
      schroot--mainline--0.1.1--base-0

    (automatically generated log message)

    new patches:
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--base-0
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-1
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-2
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-3
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-4
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-5
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-6
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-7
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-8
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-9
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-10
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-11
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-12
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-13
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-14
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-15
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-16
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-17
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-18
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-19
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--patch-20
     rleigh@debian.org--2005-debian/schroot--mainline--0.1.0--version-0


2005-06-19 17:00:46 GMT	Roger Leigh <rleigh@debian.org>	version-0

    Summary:
      0.1.0 released.
    Revision:
      schroot--mainline--0.1.0--version-0

    - Preparation for 0.1.0.

    modified files:
     AUTHORS NEWS debian/changelog


2005-06-19 16:29:07 GMT	Roger Leigh <rleigh@debian.org>	patch-20

    Summary:
      Update configuration file
    Revision:
      schroot--mainline--0.1.0--patch-20

    - Comment out all entries in the sample configuration file, so that
      the installation is secure from the start.
    - Add comments to the top of the configuration file.

    modified files:
     schroot/schroot.conf


2005-06-19 15:55:26 GMT	Roger Leigh <rleigh@debian.org>	patch-19

    Summary:
      Add initial Debian packaging
    Revision:
      schroot--mainline--0.1.0--patch-19

    - Add debian directory and initial files.
    - Makefile.am: add debian to SUBDIRS.

    new files:
     debian/.arch-ids/=id debian/.arch-ids/README.Debian.id
     debian/.arch-ids/changelog.id debian/.arch-ids/compat.id
     debian/.arch-ids/conffiles.id debian/.arch-ids/control.id
     debian/.arch-ids/copyright.id debian/.arch-ids/docs.id
     debian/.arch-ids/rules.id debian/README.Debian
     debian/changelog debian/compat debian/conffiles debian/control
     debian/copyright debian/docs debian/rules

    modified files:
     Makefile.am

    new directories:
     debian debian/.arch-ids


2005-06-19 14:06:22 GMT	Roger Leigh <rleigh@debian.org>	patch-18

    Summary:
      Run a real login shell
    Revision:
      schroot--mainline--0.1.0--patch-18

    - SbuildSession: If no environment has been set, and no command has been
      specified, run a real login shell by prefixing - to argv[0].

    modified files:
     schroot/sbuild-session.c


2005-06-19 13:23:46 GMT	Roger Leigh <rleigh@debian.org>	patch-17

    Summary:
      Implement --quiet option
    Revision:
      schroot--mainline--0.1.0--patch-17

    - SbuildSession
      + Add "quiet" property, and get_quiet and set_quiet methods.
      + Only print fatal error messages if quiet is true.
    - schroot.c: If --quiet is used, set the session quiet status.

    modified files:
     TODO doc/schroot/schroot-sections.txt
     doc/schroot/tmpl/sbuild-session.sgml schroot/sbuild-session.c
     schroot/sbuild-session.h schroot/schroot.c


2005-06-19 13:01:06 GMT	Roger Leigh <rleigh@debian.org>	patch-16

    Summary:
      Add --enable-debug configure option
    Revision:
      schroot--mainline--0.1.0--patch-16

    - Add --enable-debug configure option
    - All source files include <config.h> to detect if debugging is
      enabled.
    - schroot.c: If debugging is enabled, install a null log handler
      for g_debug messages.
    - SbuildSession: add a missing "gid" property.
    - Add the initial project requirements file.

    new files:
     doc/.arch-ids/REQUIREMENTS.id doc/REQUIREMENTS

    modified files:
     configure.ac doc/schroot/tmpl/sbuild-session.sgml
     schroot/sbuild-chroot.c schroot/sbuild-config.c
     schroot/sbuild-session.c schroot/schroot.c


2005-06-19 11:32:37 GMT	Roger Leigh <rleigh@debian.org>	patch-15

    Summary:
      Enable preservation of user environment
    Revision:
      schroot--mainline--0.1.0--patch-15

    - SbuildSession:
      + Add public get_environment and set_environment methods, and
        an environment data member and property.
      + Add private pam_setupenv method to copy environment into PAM.
      + sbuild_session_run: After authentication has succeeded, call
        pam_setupenv.
    + schroot.c:
      Call sbuild_session_set_environment if required.

    modified files:
     TODO doc/schroot/schroot-sections.txt
     doc/schroot/tmpl/sbuild-session.sgml schroot/sbuild-session.c
     schroot/sbuild-session.h schroot/schroot.1.in
     schroot/schroot.c


2005-06-19 10:47:54 GMT	Roger Leigh <rleigh@debian.org>	patch-14

    Summary:
      Return child exit status
    Revision:
      schroot--mainline--0.1.0--patch-14

    - Propagate child exit status bacl to caller.
    - Update TODO.

    modified files:
     TODO doc/schroot/tmpl/sbuild-session.sgml
     schroot/sbuild-session.c schroot/sbuild-session.h
     schroot/schroot.c


2005-06-19 10:27:37 GMT	Roger Leigh <rleigh@debian.org>	patch-13

    Summary:
      Document internal API
    Revision:
      schroot--mainline--0.1.0--patch-13

    - Document internals (private functions).
    - Update TODO.

    modified files:
     TODO schroot/sbuild-chroot.c schroot/sbuild-config.c
     schroot/sbuild-session.c schroot/schroot.c


2005-06-18 23:37:36 GMT	Roger Leigh <rleigh@debian.org>	patch-12

    Summary:
      Update TODO
    Revision:
      schroot--mainline--0.1.0--patch-12

    - Remove gtk-doc item.

    modified files:
     TODO


2005-06-18 23:36:40 GMT	Roger Leigh <rleigh@debian.org>	patch-11

    Summary:
      Fix const correctness
    Revision:
      schroot--mainline--0.1.0--patch-11

    - schroot.c:
      + Cast const GList * to GList * to work around const-correctness
        bugs in GLib.
      + All options are non-const.

    modified files:
     schroot/schroot.c


2005-06-18 23:32:14 GMT	Roger Leigh <rleigh@debian.org>	patch-10

    Summary:
      Document all user-visible symbols.
    Revision:
      schroot--mainline--0.1.0--patch-10

    - Document all user-visible symbols with gtk-doc.

    modified files:
     doc/schroot/tmpl/sbuild-chroot.sgml
     doc/schroot/tmpl/sbuild-config.sgml
     doc/schroot/tmpl/sbuild-session.sgml schroot/sbuild-chroot.c
     schroot/sbuild-config.c schroot/sbuild-session.c


2005-06-18 21:45:22 GMT	Roger Leigh <rleigh@debian.org>	patch-9

    Summary:
      Add gtk-doc framework
    Revision:
      schroot--mainline--0.1.0--patch-9

    - Added gtk-doc API reference to doc/schroot.
    - Updated README.
    - Updated TODO.

    new files:
     doc/.arch-ids/=id doc/.arch-ids/Makefile.am.id doc/Makefile.am
     doc/schroot/.arch-ids/.arch-inventory.id
     doc/schroot/.arch-ids/=id doc/schroot/.arch-ids/Makefile.am.id
     doc/schroot/.arch-ids/schroot-docs.sgml.id
     doc/schroot/.arch-ids/schroot-overrides.txt.id
     doc/schroot/.arch-ids/schroot-sections.txt.id
     doc/schroot/.arch-ids/schroot.types.id
     doc/schroot/.arch-inventory doc/schroot/Makefile.am
     doc/schroot/schroot-docs.sgml
     doc/schroot/schroot-overrides.txt
     doc/schroot/schroot-sections.txt doc/schroot/schroot.types
     doc/schroot/tmpl/.arch-ids/=id
     doc/schroot/tmpl/.arch-ids/sbuild-chroot.sgml.id
     doc/schroot/tmpl/.arch-ids/sbuild-config.sgml.id
     doc/schroot/tmpl/.arch-ids/sbuild-session.sgml.id
     doc/schroot/tmpl/.arch-ids/schroot-unused.sgml.id
     doc/schroot/tmpl/sbuild-chroot.sgml
     doc/schroot/tmpl/sbuild-config.sgml
     doc/schroot/tmpl/sbuild-session.sgml
     doc/schroot/tmpl/schroot-unused.sgml

    modified files:
     Makefile.am README TODO configure.ac schroot/.arch-inventory
     schroot/Makefile.am schroot/sbuild-session.c
     schroot/sbuild-session.h

    new directories:
     doc doc/.arch-ids doc/schroot doc/schroot/.arch-ids
     doc/schroot/tmpl doc/schroot/tmpl/.arch-ids


2005-06-18 21:08:53 GMT	Roger Leigh <rleigh@debian.org>	patch-8

    Summary:
      Improve syslog support
    Revision:
      schroot--mainline--0.1.0--patch-8

    - schroot.c:
      + Use LOG_NDELAY with openlog(), otherwise messages in child processes
        are not correctly logged.
    - SbuildSession:
      + Log command or shell being run.
      + Log authentication or permissions failures.
      + Call pam_open_session correctly.

    modified files:
     schroot/sbuild-session.c schroot/schroot.c


2005-06-18 19:47:27 GMT	Roger Leigh <rleigh@debian.org>	patch-7

    Summary:
      Add session properties and PAM debugging statements
    Revision:
      schroot--mainline--0.1.0--patch-7

    - SbuildSession
      + Add read-only properties for uid, gid, shell, ruid and ruser.
      + Add PAM debugging statements to track PAM failure paths.
    - Updated TODO.

    modified files:
     TODO schroot/sbuild-session.c


2005-06-18 19:13:21 GMT	Roger Leigh <rleigh@debian.org>	patch-6

    Summary:
      Tighten up root access
    Revision:
      schroot--mainline--0.1.0--patch-6

    - sbuild_session_require_auth(): Check that the user is in both
      groups and root_groups for all chroots before granting access.

    modified files:
     schroot/sbuild-session.c


2005-06-18 12:30:50 GMT	Roger Leigh <rleigh@debian.org>	patch-5

    Summary:
      Add manual pages and TODO
    Revision:
      schroot--mainline--0.1.0--patch-5

    - Add sbuild.1.in and sbuild.conf.5.in manual pages.
    - Add TODO
    - Fix typo in sbuild-session.c.

    new files:
     .arch-ids/TODO.id TODO schroot/.arch-ids/schroot.1.in.id
     schroot/.arch-ids/schroot.conf.5.in.id schroot/schroot.1.in
     schroot/schroot.conf.5.in

    modified files:
     configure.ac schroot/Makefile.am schroot/sbuild-session.c


2005-06-18 12:20:34 GMT	Roger Leigh <rleigh@debian.org>	patch-4

    Summary:
      Improve session error handling and authorisation
    Revision:
      schroot--mainline--0.1.0--patch-4

    - SbuildSession:
      + Use GError checks with nested conditionals so that we can shut down
        the PAM library in the correct order on failure.  The first failure
        only is reported in the case of multiple errors being propagated.
      + The root user is always granted unconditional access
      + If the host and chroot user are the same, authentication is not
        required.
      + If the user is not in groups, they do not get any access, even
        with a password.  root access still needs tighter checking.

    modified files:
     schroot/sbuild-session.c


2005-06-18 10:37:12 GMT	Roger Leigh <rleigh@debian.org>	patch-3

    Summary:
      Split PAM calls into separate functions
    Revision:
      schroot--mainline--0.1.0--patch-3

    - SbuildSession:
      + Each PAM call (or related set of calls) is a separate function
        (sbuild_session_pam_*).
      + PAM errors are propagated back to the caller using GError.
      + sbuild_session_run prototype changed to propagate any PAM or
        session errors to the caller.
    - SbuildConfig:
      + sbuild.conf does not require root group ownership, to allow
        more flexible administration.
    - schroot.c: Use GError to detect any session errors.

    modified files:
     schroot/sbuild-config.c schroot/sbuild-session.c
     schroot/sbuild-session.h schroot/schroot.c


2005-06-17 22:00:59 GMT	Roger Leigh <rleigh@debian.org>	patch-2

    Summary:
      Add PAM configuration file
    Revision:
      schroot--mainline--0.1.0--patch-2

    - Add schroot/pam/schroot containing a PAM configuration file to
      install in /etc/pam.d/schroot.

    new files:
     schroot/pam/.arch-ids/=id schroot/pam/.arch-ids/Makefile.am.id
     schroot/pam/.arch-ids/schroot.id schroot/pam/Makefile.am
     schroot/pam/schroot

    modified files:
     configure.ac schroot/Makefile.am

    new directories:
     schroot/pam schroot/pam/.arch-ids


2005-06-17 20:52:04 GMT	Roger Leigh <rleigh@debian.org>	patch-1

    Summary:
      Add autotools framework
    Revision:
      schroot--mainline--0.1.0--patch-1

    - Add support for autoconf, automake and libtool.
    - Add support for gtk-doc.
    - Install schroot setuid root.
    - Add --version option and embed version number in the output.
    - Add AUTHORS and NEWS files.
    - Generate ChangeLog with tla.

    new files:
     .arch-ids/AUTHORS.id .arch-ids/Makefile.am.id
     .arch-ids/NEWS.id .arch-ids/bootstrap.id
     .arch-ids/configure.ac.id AUTHORS Makefile.am NEWS bootstrap
     configure.ac schroot/.arch-ids/Makefile.am.id
     schroot/Makefile.am

    modified files:
     schroot/schroot.c


2005-06-17 17:51:17 GMT	Roger Leigh <rleigh@debian.org>	base-0

    Summary:
      Initial import
    Revision:
      schroot--mainline--0.1.0--base-0

    Initial import into GNU Arch.

    new files:
     COPYING README schroot/sbuild-chroot.c schroot/sbuild-chroot.h
     schroot/sbuild-config.c schroot/sbuild-config.h
     schroot/sbuild-session.c schroot/sbuild-session.h
     schroot/schroot.c schroot/schroot.conf
